#include "code/framework/I18nResourceBundle.h"
#include <oslib/oslib.h>
#include <map>
#include <fstream>
#include "code/framework/utils.h"
#include "code/framework/check/loaders.h"

using namespace utils;
using namespace std;

I18nResourceBundle::I18nResourceBundle(string locale, string filename)
{
	m_bundle=new map<string, string>();
	m_locale=locale;
	
	string file(I18N_RESOURCES+locale+"/"+filename);
	ifstream properties_file;
	fwkOpenTextFile(file, &properties_file);
	
	string line;
	while(getline(properties_file, line))
	{
		if(line.find("[") != 0) //ne pas prendre les commentaires en compte
		{
			if(line.size()>2) //ne pas prendre en compte les lignes vides, au minimum "a=b"
			{
				int indice=line.find("=");
				string key=line.substr(0, indice); //longueur = indice
				string value=line.substr(indice+1, line.size()-1-indice);
				
				value=deleteAll(value, "\r");
				
				m_bundle->insert(pair<string, string>(key, value));
			}
		}
	}
	
	properties_file.close();
}

I18nResourceBundle::~I18nResourceBundle()
{
	/*map<string, string *>::iterator it;
	for (it=m_bundle->begin() ; it!=m_bundle->end(); it++)
	{
		delete (*it).second;
	}*/
	
	delete m_bundle;
}

string  I18nResourceBundle::getMessage(string key) const
{
	map<string, string>::iterator it=m_bundle->find(key);
	if(it!=m_bundle->end())
	{
		//string * res = new string(*((*it).second)); //appelle le constructeur par copie, (*it).second est un string *, on déréférence avec *
		return (*it).second;
	}
	return "#"+key+"_"+m_locale+"#";
}













