#ifndef PROPERTIES_H_
#define PROPERTIES_H_

#include <map>
#include <string>
#include <iostream>
#include <sstream>
#include <oslib/oslib.h>

using namespace std;

class Properties
{
	private:
		map<string, string> * properties;
		bool m_fatalErrorEnabled;
	
	public:
		Properties();
		Properties(string filename);
		Properties(istream *stream);
		~Properties();
	
		void loadFromFile(string filename);
		void loadFromStream(istream *stream);
		void saveToFile(string filename);
		string toString();
		void loadFromString(string str);
		
		string getStrValue(string key);
		int getIntValue(string key);
		float getFloatValue(string key);
		OSL_COLOR getColorValue(string key);
		bool getBoolValue(string key);
		
		string getStrValue(string key, string def);
		int getIntValue(string key, int def);
		float getFloatValue(string key, float def);
		OSL_COLOR getColorValue(string key, OSL_COLOR def);
		bool getBoolValue(string key, bool def);
		
		
		void setValue(string key, string value);
		void setValue(string key, int value);
		
		void setFatalError(bool enable=true);
		
		bool containsKey(string key);
};

#endif /*PROPERTIES_H_*/
