#include "code/framework/anim/ImageAndAttr.h"
#include "code/framework/utils.h"
#include "code/framework/check/loaders.h"

using namespace utils;

ImageAndAttr::ImageAndAttr(string filename, short transparency)
{
	m_img = fwkLoadImageFilePNG(filename, OSL_IN_RAM | OSL_SWIZZLED, transparency);
		
//	if(!m_img)
//	{
//		oslStartDrawing();
//		oslFatalError(("cannot load image file : "+filename).c_str());
//		oslEndDrawing();
//		oslSyncFrame();
//	}
	m_name=filename;
	m_nbRef=0;
}

ImageAndAttr::ImageAndAttr(OSL_IMAGE *image, string imageID)
{
	m_img=image;
	m_name=imageID;
	m_nbRef=0;
}

//copie, c'est un singleton on n'ecrit pas son contenu
ImageAndAttr::ImageAndAttr(const ImageAndAttr &iaa)
{
	//m_img=oslCreateImageCopy(m_img, m_img->location); 
	m_img=oslCreateSwizzledImage(m_img, m_img->location); 
	if(m_img==NULL)
	{
		fatalError("ImageAndAttr : could not create a copy of image "+iaa.m_name);
	}
	m_name=iaa.m_name; 
	m_nbRef=0; //on considere que les references restent sur l'ancienne image, et non la copie
}
//idem pour l'affectation
ImageAndAttr& ImageAndAttr::operator =(const ImageAndAttr& iaa)
{

   	//m_img=oslCreateImageCopy(m_img, m_img->location); 
   	m_img=oslCreateSwizzledImage(m_img, m_img->location);
	m_name=iaa.m_name; 
	m_nbRef=0; //on considere que les references restent sur l'ancienne image, et non la copie
    return *this;
}

//destructeur
ImageAndAttr::~ImageAndAttr()
{

	if(m_img!=NULL)
		oslDeleteImage(m_img);
}




//getters
OSL_IMAGE *ImageAndAttr::getImage() const
{
	return m_img;
}

string ImageAndAttr::getName() const
{
	return m_name;
}

int ImageAndAttr::getNbRef() const
{
	return m_nbRef;	
}

//others
int ImageAndAttr::addRef(int nb) //ajoute 1 au nombre de references
{
	m_nbRef+=nb;
	return m_nbRef;
}

int ImageAndAttr::subRef(int nb) //enleve 1 au nombre de references
{
	m_nbRef-=nb;
	return m_nbRef;
}




