#ifndef IMAGEANDATTR_
#define IMAGEANDATTR_

#include <iostream>
#include <string>

#include "OSLib/oslib.h"
//#include "code/framework/settings.h"
//#include "code/framework/def.h"

using namespace std;


//class utilisée uniquement par les anims
//elle possède des pointeurs "intelligents" qui lors d'une demande de chargement d'une
//image, vont rechercher via leur nom si elle n'existe pas déjà. Si oui elle renvoie 
//un pointeur vers celle ci, sinon elle charge. Une fois qu'une image n'a plus de 
//pointeurs sur elle, elle est détruite par défaut.
//voir la class Anim.
class ImageAndAttr
{
	private:
		
		//members
		OSL_IMAGE *m_img; //l'image
		string m_name; //le nom du fichier, utilisé pour discriminer les images
		int m_nbRef; //le nombre de pointeurs vers cette image (nbre d'anims qui l'utilisent)
		
		//constructeur de copie, private car singleton
		ImageAndAttr(const ImageAndAttr &iaa);
		//operateur d'affectation, private car singleton
		ImageAndAttr& operator=(const ImageAndAttr& Other);
		
	public:
		//constructor, use this one!
		ImageAndAttr(string filename, short transparency);
		ImageAndAttr(OSL_IMAGE *image, string imageId);
		
		//destructor
		~ImageAndAttr();
		
		//getters
		OSL_IMAGE *getImage() const;
		string getName() const;
		int getNbRef() const;
		
		//others
		int addRef(int nb=1); //ajoute 1 au nombre de references
		int subRef(int nb=1); //enleve 1 au nombre de references
};


#endif /*IMAGEANDATTR_*/
