#ifndef ABSTRACTLOCALEFFECT_H_
#define ABSTRACTLOCALEFFECT_H_

#include "code/framework/fx/abstract/AbstractEffect.h"
#include "code/framework/interfaces/Positionable.h"
#include "code/framework/interfaces/Orientable.h"
#include "code/framework/interfaces/Resizable.h"
//classe parente de tous les effets locaux (taille, position, rotation...)
class AbstractLocalEffect : public AbstractEffect
{
	public:
		virtual OSL_IMAGE * applyOn(OSL_IMAGE *img)=0; //avant le dessin, pour chaque image, pour les effets locaux ie: pos, rot, stretch
		virtual Positionable *applyOnPositionable(Positionable *obj){return obj;}
		virtual Orientable *applyOnOrientable(Orientable *obj){return obj;}
		virtual Resizable *applyOnResizable(Resizable *obj){return obj;}
		virtual ~AbstractLocalEffect(){}
		virtual AbstractLocalEffect* clone() const=0;
		virtual int getPosX(){return 0;}
		virtual int getPosY(){return 0;}
		virtual int getOrientation(){return 0;}
};

#endif /*ABSTRACTLOCALEFFECT_H_*/
