#ifndef SERIALGLOBALEFFECT_H_
#define SERIALGLOBALEFFECT_H_

#include "code/framework/fx/abstract/AbstractGlobalEffect.h"
#include <vector>
using namespace std;

//prend en charge la destruction du contenu
class SerialGlobalEffect : public AbstractGlobalEffect
{
	private:
		vector<AbstractGlobalEffect *> *m_effects;
		unsigned int m_currentEffect;
		int m_nbLoops;
		int m_currentLoop;
	
	public:
		SerialGlobalEffect(int nbLoops=-1);
		~SerialGlobalEffect();
	
		void start(); 
		void restart();
		void reset();
		void stop();
		void update();
		bool finished();
		bool isRunning();
		void activate();
		
		void addEffect(AbstractGlobalEffect * fx);
		SerialGlobalEffect* clone() const;
};

#endif /*SERIALGLOBALEFFECT_H_*/
