#include "code/framework/fx/impl/global/multi/WaitGlobalEffect.h"

WaitGlobalEffect::WaitGlobalEffect(unsigned int time)
{
	m_running=false;
	m_time=time;
	m_currentTick=0;
}
	
void WaitGlobalEffect::start()
{
	m_running=true;
} 
void WaitGlobalEffect::restart()
{
	m_running=true;
	m_currentTick=0;
}
void WaitGlobalEffect::reset()
{
	m_currentTick=0;
}
void WaitGlobalEffect::stop()
{
	m_running=false;
}
void WaitGlobalEffect::update()
{
	m_currentTick++;
	if(finished())
		m_running=false;
}
bool WaitGlobalEffect::finished()
{
	if(m_currentTick>=m_time-1)
		return true;
	return false;
}
bool WaitGlobalEffect::isRunning()
{
	return m_running;
}

void WaitGlobalEffect::activate()
{
	
}

WaitGlobalEffect* WaitGlobalEffect::clone() const
{
	return new WaitGlobalEffect(m_time);
}

unsigned int WaitGlobalEffect::getTime()
{
	return m_time;
}

void WaitGlobalEffect::setTime(unsigned int time)
{
	m_time=time;
}




