#include "code/framework/fx/impl/local/AppearDownEffect.h"
#include "code/framework/utils.h"
#include <oslib/oslib.h>

using namespace utils;

AppearDownEffect::AppearDownEffect(unsigned int time)
{
	m_running=false;
	m_curTick=0;
	m_time=time;
}
	
void AppearDownEffect::start()
{
	m_running=true;
}
 
void AppearDownEffect::restart()
{
	m_curTick=0;
	m_running=true;
}

void AppearDownEffect::reset()
{
	m_curTick=0;
}

void AppearDownEffect::stop()
{
	m_running=false;
}

void AppearDownEffect::update()
{
	if(m_running)
	{
		m_curTick++;
		if(finished())
		{
			m_running=false;	
		}
	}
}

bool AppearDownEffect::finished()
{
	if(m_curTick>=m_time)
		return true;
	return false;
}

bool AppearDownEffect::isRunning()
{
	return m_running;
}

OSL_IMAGE * AppearDownEffect::applyOn(OSL_IMAGE *img)
{

	if(img==NULL)
		return NULL;
		
	//m_curTick;
	//m_time;
	int height=oslGetImageHeight(img);
	int curSize=int((m_curTick*height)/m_time);
	int sizeDiffY=height-curSize;
	
	//img->offsetY0-=sizeDiffY;
	//img->offsetY1=img->offsetY0+10;
	//img->offsetY1++;//dernier exclus.
	img->y+=sizeDiffY;
	oslSetImageTile(img, img->offsetX0, img->offsetY0, img->offsetX1, img->offsetY1-sizeDiffY);
	if(img->offsetY1==img->offsetY0)
		img->offsetY1=img->offsetY1+1;

	
	return img;
}
 
AppearDownEffect* AppearDownEffect::clone() const
{
	return new AppearDownEffect(m_time);
}




















