#include "code/framework/fx/impl/local/AppearUpEffect.h"
#include "code/framework/utils.h"
#include <oslib/oslib.h>

using namespace utils;

AppearUpEffect::AppearUpEffect(unsigned int time)
{
	m_running=false;
	m_curTick=0;
	m_time=time;
}
	
void AppearUpEffect::start()
{
	m_running=true;
}
 
void AppearUpEffect::restart()
{
	m_curTick=0;
	m_running=true;
}

void AppearUpEffect::reset()
{
	m_curTick=0;
}

void AppearUpEffect::stop()
{
	m_running=false;
}

void AppearUpEffect::update()
{
	if(m_running)
	{
		m_curTick++;
		if(finished())
		{
			m_running=false;	
		}
	}
}

bool AppearUpEffect::finished()
{
	if(m_curTick==m_time)
		return true;
	return false;
}

bool AppearUpEffect::isRunning()
{
	return m_running;
}

OSL_IMAGE * AppearUpEffect::applyOn(OSL_IMAGE *img)
{
	if(img==NULL)
		return NULL;
	
	int height=oslGetImageHeight(img);
	int curSize=int((m_curTick*height)/m_time);
	int sizeDiffY=height-curSize;
	
	//img->y-=sizeDiffY;
	oslSetImageTile(img, img->offsetX0, img->offsetY0+sizeDiffY, img->offsetX1, img->offsetY1);
	if(img->offsetY1==img->offsetY0)
		img->offsetY1=img->offsetY1+1;
	
	return img;
}
 
AppearUpEffect* AppearUpEffect::clone() const
{
	return new AppearUpEffect(m_time);
}



















