#ifndef ROTATEBACKANDFORTHEFFECT_H_
#define ROTATEBACKANDFORTHEFFECT_H_

#include "code/framework/fx/abstract/AbstractLocalEffect.h"

//effet local
//permet d'afficher une image pendant un certain temps, puis plus rien
class RotateBackAndForthEffect : public AbstractLocalEffect
{
	private:
		bool m_running;
		int m_time;
		int m_nbLoops;
		int m_curTime;
		int m_curLoop;	
		int m_from;
		int m_to;
		bool m_direction;
	
	public:
		RotateBackAndForthEffect(int time, int from, int to, int nbLoops=-1); //-1 = infinite
	
		void start(); 
		void restart();
		void reset();
		void stop();
		void update();
		bool finished();
		bool isRunning();
		OSL_IMAGE * applyOn(OSL_IMAGE *); 
		//OSL_IMAGE * unapplyOn(OSL_IMAGE *);
		RotateBackAndForthEffect* clone() const;
		
		Orientable *applyOnOrientable(Orientable *obj);
		
		void setTime(int time);
		int getTime();
		
		int getOrientation();
};
#endif /*ROTATEBACKANDFORTHEFFECT_H_*/
