#include "code/framework/fx/impl/local/VanishDownEffect.h"
#include "code/framework/utils.h"
#include <oslib/oslib.h>

using namespace utils;

VanishDownEffect::VanishDownEffect(unsigned int time)
{
	m_running=false;
	m_curTick=0;
	m_time=time;
}
	
void VanishDownEffect::start()
{
	m_running=true;
}
 
void VanishDownEffect::restart()
{
	m_curTick=0;
	m_running=true;
}

void VanishDownEffect::reset()
{
	m_curTick=0;
}

void VanishDownEffect::stop()
{
	m_running=false;
}

void VanishDownEffect::update()
{
	if(m_running)
	{
		m_curTick++;
		if(finished())
		{
			m_running=false;	
		}
	}
}

bool VanishDownEffect::finished()
{
	if(m_curTick==m_time)
		return true;
	return false;
}

bool VanishDownEffect::isRunning()
{
	return m_running;
}

OSL_IMAGE * VanishDownEffect::applyOn(OSL_IMAGE *img)
{
	if(img==NULL || finished())
		return NULL;

	int height=oslGetImageHeight(img);
	int curSize=int((m_curTick*height)/m_time);
	//int sizeDiffY=height-curSize;

	//img->y-=sizeDiffY;
	oslSetImageTile(img, img->offsetX0, img->offsetY0, img->offsetX1, img->offsetY1-curSize);
	img->y+=curSize;
	if(img->offsetY1==img->offsetY0)
		img->offsetY1=img->offsetY1+1;
		
	return img;
}

VanishDownEffect* VanishDownEffect::clone() const
{
	return new VanishDownEffect(m_time);
}







