#include "code/framework/fx/impl/local/VanishUpEffect.h"
#include "code/framework/utils.h"
#include <oslib/oslib.h>

using namespace utils;

VanishUpEffect::VanishUpEffect(unsigned int time)
{
	m_running=false;
	m_curTick=0;
	m_time=time;
}
	
void VanishUpEffect::start()
{
	m_running=true;
}
 
void VanishUpEffect::restart()
{
	m_curTick=0;
	m_running=true;
}

void VanishUpEffect::reset()
{
	m_curTick=0;
}

void VanishUpEffect::stop()
{
	m_running=false;
}

void VanishUpEffect::update()
{
	if(m_running)
	{
		m_curTick++;
		if(finished())
		{
			m_running=false;	
		}
	}
}

bool VanishUpEffect::finished()
{
	if(m_curTick==m_time)
		return true;
	return false;
}

bool VanishUpEffect::isRunning()
{
	return m_running;
}

OSL_IMAGE * VanishUpEffect::applyOn(OSL_IMAGE *img)
{
	if(img==NULL || finished())
		return NULL;

	int height=oslGetImageHeight(img);
	int curSize=int((m_curTick*height)/m_time);
	//int sizeDiffY=height-curSize;

	//img->y-=sizeDiffY;
	oslSetImageTile(img, img->offsetX0, img->offsetY0+curSize, img->offsetX1, img->offsetY1);
	//img->y-=curSize;
	if(img->offsetY1==img->offsetY0)
		img->offsetY1=img->offsetY1+1;
		
	return img;
}

VanishUpEffect* VanishUpEffect::clone() const
{
	return new VanishUpEffect(m_time);
}







