#include "code/framework/fx/impl/managers/SimpleEffectManager.h"
#include "code/framework/fx/abstract/AbstractEffect.h"
#include <list>
#include "code/framework/utils.h"
using namespace std;
using namespace utils;

SimpleEffectManager::SimpleEffectManager()
{
	m_effects=new list<AbstractEffect *>();
}

void SimpleEffectManager::start()
{
	for(list<AbstractEffect *>::iterator it=m_effects->begin() ; it!=m_effects->end();it++)	
	{
		(*it)->start();	
	}
}

void SimpleEffectManager::restart()
{
	for(list<AbstractEffect *>::iterator it=m_effects->begin() ; it!=m_effects->end();it++)	
	{
		(*it)->restart();	
	}
}

void SimpleEffectManager::reset()
{
	for(list<AbstractEffect *>::iterator it=m_effects->begin() ; it!=m_effects->end();it++)	
	{
		(*it)->reset();	
	}
}

void SimpleEffectManager::stop()
{
	for(list<AbstractEffect *>::iterator it=m_effects->begin() ; it!=m_effects->end();it++)	
	{
		(*it)->stop();	
	}
}

void SimpleEffectManager::update()
{
	for(list<AbstractEffect *>::iterator it=m_effects->begin() ; it!=m_effects->end();it++)	
	{
		(*it)->update();	
	}
}

//doivent tous etre terminés pour être considéré terminé
bool SimpleEffectManager::finished()
{
	for(list<AbstractEffect *>::iterator it=m_effects->begin() ; it!=m_effects->end();it++)	
	{
		if(!(*it)->finished())
		{
			return false;	
		}
	}
	return true;
}

//si un seul est encore running, on le considere running
bool SimpleEffectManager::isRunning()
{
	for(list<AbstractEffect *>::iterator it=m_effects->begin();it!=m_effects->end();it++)	
	{
		if((*it)->isRunning())
		{
			return true;	
		}
	}
	return false;
}

		


void SimpleEffectManager::deleteAll()
{
	while(!m_effects->empty())
	{
		AbstractEffect * front=m_effects->front();
		m_effects->pop_front();
		delete front;
	}
}

		
SimpleEffectManager::~SimpleEffectManager()
{
	delete m_effects;
}













