#ifndef EFFECTSUTILS_H_
#define EFFECTSUTILS_H_

#include <OSLib/oslib.h>
#include "code/framework/fx/utils/ImgState.h"
#include "code/framework/fx/abstract/AbstractLocalEffect.h"
#include "code/framework/State.h"

namespace fx
{
	static ImgState imgstate;
	static State state;
	
	//dessine une image avec jusqu'à 5 effets locaux simultanés
	void draw(OSL_IMAGE *img, AbstractLocalEffect *fx1=NULL, AbstractLocalEffect *fx2=NULL, AbstractLocalEffect *fx3=NULL, AbstractLocalEffect *fx4=NULL, AbstractLocalEffect *fx5=NULL);
	void drawXY(OSL_IMAGE *img, int x, int y, AbstractLocalEffect *fx1=NULL, AbstractLocalEffect *fx2=NULL, AbstractLocalEffect *fx3=NULL, AbstractLocalEffect *fx4=NULL, AbstractLocalEffect *fx5=NULL);
	//void test(string ** strTable);
	void saveState(StateSavable *obj);
	void restoreState(StateSavable *obj);
	Positionable * applyFxOnPositionable(Positionable *obj, AbstractLocalEffect *fx1, AbstractLocalEffect *fx2=NULL, AbstractLocalEffect *fx3=NULL, AbstractLocalEffect *fx4=NULL, AbstractLocalEffect *fx5=NULL); 
	Orientable * applyFxOnOrientable(Orientable *obj, AbstractLocalEffect *fx1, AbstractLocalEffect *fx2=NULL, AbstractLocalEffect *fx3=NULL, AbstractLocalEffect *fx4=NULL, AbstractLocalEffect *fx5=NULL); 
	Resizable * applyFxOnResizable(Resizable *obj, AbstractLocalEffect *fx1, AbstractLocalEffect *fx2=NULL, AbstractLocalEffect *fx3=NULL, AbstractLocalEffect *fx4=NULL, AbstractLocalEffect *fx5=NULL); 
	//StateSavable *applyFxOn(StateSavable *obj, AbstractLocalEffect *fx1, AbstractLocalEffect *fx2=NULL, AbstractLocalEffect *fx3=NULL, AbstractLocalEffect *fx4=NULL, AbstractLocalEffect *fx5=NULL); 
}

//inline
inline void fx::drawXY(OSL_IMAGE *img, int x, int y, AbstractLocalEffect *fx1, AbstractLocalEffect *fx2, AbstractLocalEffect *fx3, AbstractLocalEffect *fx4, AbstractLocalEffect *fx5)
{
	int orx=img->x;
	int ory=img->y;
	img->x=x;
	img->y=y;
	fx::draw(img, fx1, fx2, fx3, fx4, fx5);
	img->x=orx;
	img->y=ory;
}

#endif /*EFFECTSUTILS_H_*/
