#ifndef MENUITEM_H_
#define MENUITEM_H_

#include <vector>
#include <string>
#include <oslib/oslib.h>
#include "code/framework/bmpFont/BmpFont.h"
using namespace std;

class MenuItem
{
	private:
		int m_selectedChild;
		int m_selectedValue;
		vector<MenuItem *> *m_subMenus;
		vector<string> *m_valueTitles;
		vector<int> *m_values;
		string m_title;
		int m_id;
		MenuItem * m_parent;
		OSL_IMAGE * m_image;
		
	public:
		MenuItem(string title, BmpFont * f, int id, MenuItem * parent, int nbChildren=0, int nbValues=0);
		//MenuItem(int nbChildren);				
		~MenuItem();
		int getSelectedChildNum();
		MenuItem * addSubMenu(MenuItem * sm);
		MenuItem * gotoNextChild();
		MenuItem * gotoPreviousChild();
		
		MenuItem * getSelectedChild();
		MenuItem * getNextChild();
		MenuItem * getAfterNextChild();
		MenuItem * getPreviousChild();
		MenuItem * getBeforePreviousChild();
		
		void addValue(string title, int value);
		int getSelectedValue();
		unsigned int getNbValues();
		int gotoNextValue();
		int gotoPreviousValue();
		string getValueTitle();
		bool hasChildren();
		bool hasValues();
		int getId();
		void setValue(int value);
		int getNbChildren();
		MenuItem * getParent();
		string getTitle();
		
		OSL_IMAGE * getImage();
};

#endif /*MENUITEM_H_*/




















