#include "code/framework/particles/complete/fxFactories/PFXFRandomAngleTranslation.h"
#include "code/framework/fx/EffectsLib.h"
#include "code/framework/utils.h"

PFXFRandomAngleTranslation::PFXFRandomAngleTranslation(int angleMin, int angleMax)
{
	m_angleMin=angleMin;
	m_angleMax=angleMax;
}

PFXFRandomAngleTranslation::~PFXFRandomAngleTranslation()
{
	
}

PFXFRandomAngleTranslation *PFXFRandomAngleTranslation::clone() const
{
	return new PFXFRandomAngleTranslation(m_angleMin, m_angleMax);
}

AbstractLocalEffect *PFXFRandomAngleTranslation::newLocalEffectInstance(int startX, int startY, int dist, int movingTime, int orientation, int scale, int particleLifespan)
{
	int rangle=utils::random(orientation+m_angleMin, orientation+m_angleMax);
	
	//point d'arrivee
	int targetY=oslSini(-rangle, dist) + startY;
	int targetX=oslCosi(-rangle, dist) + startX;
	
	TranslationEffect *fx_transl=new TranslationEffect(startX, startY, targetX, targetY, movingTime, movingTime, true, 1);
	return fx_transl;
}
	
int PFXFRandomAngleTranslation::getAngleMin()
{
	return m_angleMin;
}

void PFXFRandomAngleTranslation::setAngleMin(int angle)
{
	m_angleMin=angle;
}

int PFXFRandomAngleTranslation::getAngleMax()
{
	return m_angleMax;
}

void PFXFRandomAngleTranslation::setAngleMax(int angle)
{
	m_angleMax=angle;
}













