#include "code/framework/particles/complete/fxFactories/PFXFRandomPosition.h"
#include "code/framework/fx/EffectsLib.h"
#include "code/framework/utils.h"


PFXFRandomPosition::PFXFRandomPosition(int distMin, int distMax)
{
	m_distMin=distMin;
	m_distMax=distMax;
}

PFXFRandomPosition *PFXFRandomPosition::clone() const
{
	return new PFXFRandomPosition(m_distMin, m_distMax);
}

PFXFRandomPosition::~PFXFRandomPosition()
{
}

AbstractLocalEffect *PFXFRandomPosition::newLocalEffectInstance(int startX, int startY, int dist, int movingTime, int orientation, int scale, int particleLifespan)
{
	int min=(m_distMin==-1?0:m_distMin);
	int max=(m_distMax==-1?dist:m_distMax);
	
	int rdist=utils::random(min, max);
	
	//point d'arrivee
	int targetY=oslSini(-orientation, rdist) + startY;
	int targetX=oslCosi(-orientation, rdist) + startX;
	
	//TranslationEffect *fx_transl=new TranslationEffect(startX, startY, targetX, targetY, movingTime, movingTime, true, 1);
	WaitLocalEffect *fx_wait=new WaitLocalEffect(particleLifespan);
	fx_wait->setPosition(targetX, targetY);
	return fx_wait;
}
	
int PFXFRandomPosition::getDistMin()
{
	return m_distMin;
}

void PFXFRandomPosition::setDistMin(int dist)
{
	m_distMin=dist;
}

int PFXFRandomPosition::getDistMax()
{
	return m_distMax;
}

void PFXFRandomPosition::setDistMax(int dist)
{
	m_distMax=dist;
}

