#include "code/framework/particles/complete/fxFactories/PFXFRandomShake.h"
#include "code/framework/fx/EffectsLib.h"
#include "code/framework/utils.h"

PFXFRandomShake::PFXFRandomShake(int widthMin, int widthMax, int heightMin, int heightMax, int timeMin, int timeMax)
{
	m_widthMin=widthMin;
	m_widthMax=widthMax;
	m_heightMin=heightMin;
	m_heightMax=heightMax;
	m_timeMin=timeMin;
	m_timeMax=timeMax;
}

PFXFRandomShake *PFXFRandomShake::clone() const
{
	return new PFXFRandomShake(m_widthMin, m_widthMax, m_heightMin, m_heightMax, m_timeMin, m_timeMax);
}

PFXFRandomShake::~PFXFRandomShake()
{
	
}

AbstractLocalEffect *PFXFRandomShake::newLocalEffectInstance(int startX, int startY, int dist, int movingTime, int orientation, int scale, int particleLifespan)
{
	int rwidth=utils::random(m_widthMin, m_widthMax);
	int rheight=utils::random(m_heightMin, m_heightMax);
	int rtime=utils::random(m_timeMin, m_timeMax);
	
	bool rdir=utils::random(0, 1);
	
	ShakeEffect * shakefx=new ShakeEffect(rwidth, rheight, rtime, rdir);
	return shakefx;
}

void PFXFRandomShake::setWidthMin(int val)
{
	m_widthMin=val;
}
void PFXFRandomShake::setWidthMax(int val)
{
	m_widthMax=val;
}
void PFXFRandomShake::setHeightMin(int val)
{
	m_heightMin=val;
}
void PFXFRandomShake::setHeightMax(int val)
{
	m_heightMax=val;
}
void PFXFRandomShake::setTimeMin(int val)
{
	m_timeMin=val;
}
void PFXFRandomShake::setTimeMax(int val)
{
	m_timeMax=val;
}

int PFXFRandomShake::getWidthMin()
{
	return m_widthMin;
}
int PFXFRandomShake::getWidthMax()
{
	return m_widthMax;
}
int PFXFRandomShake::getHeightMin()
{
	return m_heightMin;
}
int PFXFRandomShake::getHeightMax()
{
	return m_heightMax;
}
int PFXFRandomShake::getTimeMin()
{
	return m_timeMin;
}
int PFXFRandomShake::getTimeMax()
{
	return m_timeMax;
}











