#ifndef PARTICLEGENERATORPOINT_H_
#define PARTICLEGENERATORPOINT_H_

#include <oslib/oslib.h>
#include <string>
#include "code/framework/particles/complete/Particle.h"
#include "code/framework/particles/complete/abstract/AbstractParticleGenerator.h"
#include <list>
#include "code/framework/interfaces/Drawable.h"
#include "code/framework/interfaces/Positionable.h"
#include "code/framework/interfaces/Playable.h"
#include "code/framework/interfaces/StateSavable.h"
#include "code/framework/State.h"
#include "code/framework/anim/Anim.h"

using namespace std;

//TODO: ajouter gestion des effets de position?
class ParticleGeneratorPoint: public AbstractParticleGenerator
{
	private:
		//calcul de l'angle min et max
		int m_scale_small;
		int m_scale_big;
		
	protected:
		virtual Particle *generateNextParticle();
				
	public:
		ParticleGeneratorPoint(	int x, int y, int direction, int scale, int nbParticles, int generationTime, int movingTime, 
									int dist, int particleLifespan, AbstractAnimationFactory *animFactory, int nbLoops=-1);
		ParticleGeneratorPoint(	int x, int y, int direction, int scale, int nbParticles, int generationTime, int movingTime, int dist, 
								int particleLifespan, Anim *anim, int nbLoops=-1);
		ParticleGeneratorPoint(	int x, int y, int direction, int scale, int nbParticles, int generationTime, int movingTime, int dist,
								int particleLifespan, string filename, short transparency, int nbLoops=-1);
		
		virtual ParticleGeneratorPoint *clone() const;
		
		virtual ~ParticleGeneratorPoint();
		
		virtual void setScale(int scale);
		virtual void setOrientation(int orientation);
};

#endif /*PARTICLEGENERATORPOINT_H_*/




