#ifndef PARTICLEGENERATORSEGMENT_H_
#define PARTICLEGENERATORSEGMENT_H_

#include <oslib/oslib.h>
#include <string>
#include "code/framework/particles/complete/Particle.h"
#include "code/framework/particles/complete/abstract/AbstractParticleGenerator.h"
#include <list>
#include "code/framework/interfaces/Drawable.h"
#include "code/framework/interfaces/Positionable.h"
#include "code/framework/interfaces/Playable.h"
#include "code/framework/interfaces/StateSavable.h"
#include "code/framework/State.h"
#include "code/framework/anim/Anim.h"

using namespace std;

class ParticleGeneratorSegment: public AbstractParticleGenerator
{
	private:
		//point A
		int m_xa;
		int m_ya;
		
		//point B
		int m_xb;
		int m_yb;
		
		void recalculateEdges();
		
		int m_scale_2; //moitie de la distance
		
	protected:
		Particle *generateNextParticle();
						
	public:
		ParticleGeneratorSegment(	int x, int y, int direction, int scale, int nbParticles, int generationTime, int movingTime, 
									int dist, int particleLifespan, AbstractAnimationFactory *animFactory, int nbLoops=-1);
		ParticleGeneratorSegment(	int x, int y, int direction, int scale, int nbParticles, int generationTime, int movingTime, 
									int dist, int particleLifespan, Anim *anim, int nbLoops=-1);
		ParticleGeneratorSegment(	int x, int y, int direction, int scale, int nbParticles, int generationTime, int movingTime, 
									int dist, int particleLifespan, string filename, short transparency, int nbLoops=-1);
		
		ParticleGeneratorSegment *clone() const;
		
		virtual ~ParticleGeneratorSegment();
		
		void setScale(int scale);
		void setOrientation(int orientation);
		
		int getXA();
		int getYA();
		int getXB();
		int getYB();
};

#endif /*PARTICLEGENERATORSEGMENT_H_*/




