#ifndef FOLDERREPO_H_
#define FOLDERREPO_H_

#include <stdio.h>
#include <string>
#include <map>
#include <oslib/oslib.h>
#include "code/framework/resRepo/ResFileDetails.h"
#include "code/framework/resRepo/abstract/AbstractResRepo.h"
#include <vector>
#include <iostream>

using namespace std;

class FolderRepo : public AbstractResRepo
{
	private:
		long m_nbFiles;
		string m_folderName;
		map<string, ResFileDetails> *m_files; //nom du fichier associé aux détails du fichier en question
		
		//nettoie les liens ("//", "/./"..)
		string uniformizePath(string path);
		
		void recurseIntoFolders(string startdir);
		
	public:
		FolderRepo(string folder);
		~FolderRepo();
		
		void init(); //l'initialisation est lazy, forcer avec cette fonction
		
	
		long getNbFiles();
		vector<string> getFilesNames();
		vector<ResFileDetails> getFilesDetails();
		ResFileDetails getFileDetails(string filename);
		FILE *open(string filename);
		string getName();
		
		string readTextFileString(string filename);
		istream *readTextFileStream(string filename); //il faudra faire un delete sur l'istream apres utilisation!
		OSL_IMAGE *readPngFile(string filename, int location, int pixelFormat);
		OSL_SOUND *readBgmFile(string filename);
		bool extractFileTo(string archivefile, string memorystickfile); //renvoie true si succès
		//TODO: untested!!
		bool extractAllToFolder(string dir);
};

#endif /*FOLDERREPO_H_*/
