#include "code/game/FlagMatrix.h"

FlagMatrix::FlagMatrix(int cols, int lines)
//: Trackable("FlagMatrix")
{	
	m_table=new bool[cols*lines];
	m_nbcols=cols;
	m_nblines=lines;
	removeAllFlags();
}

FlagMatrix::~FlagMatrix()
{
	delete[] m_table;
}

void FlagMatrix::setFlagAt(int col, int line, bool b)
{
	m_table[col+line*m_nbcols]=b;
}

bool FlagMatrix::isFlagSetAt(int col, int line)
{
	return m_table[col+line*m_nbcols];
}

int FlagMatrix::getNbFlagsSet()
{
	int nb=0;
	for(int i=0;i<m_nbcols*m_nblines;i++)
	{
		if(m_table[i])
			nb++;
	}
	return nb;
}

int FlagMatrix::getNbFlagsNotSet()
{
	int nb=0;
	for(int i=0;i<m_nbcols*m_nblines;i++)
	{
		if(!m_table[i])
			nb++;
	}
	return nb;
}

int FlagMatrix::getNbLines()
{
	return m_nblines;
}

int FlagMatrix::getNbCols()
{
	return m_nbcols;
}

void FlagMatrix::removeAllFlags()
{
	for(int i=0;i<m_nbcols*m_nblines;i++)
	{
		m_table[i]=false;
	}
}

void FlagMatrix::setAllFlags()
{
	for(int i=0;i<m_nbcols*m_nblines;i++)
	{
		m_table[i]=true;
	}
}






