#include "code/game/PositionsBuffer.h"
#include <oslib/oslib.h>

PositionsBuffer::PositionsBuffer(int nbCols, int nbLines, int posX, int posY, int cellWidth, int cellHeight)
{
	m_nbCols=nbCols;
	m_nbLines=nbLines;
	
	//axe des x:
	m_x=new short[m_nbCols];
	for(int i=0;i<m_nbCols;i++)
	{
		m_x[i]=posX+i*cellWidth+short(cellWidth/2);
	}
	
	//axe des y:
	//attention, le buffer autorise les demandes de y jusqu'à -3 qui correspond à la case numero 0
	m_y=new short[nbLines+3];
	posY=posY-(3*cellHeight);
	for(int i=0;i<nbLines+3;i++)
	{
		m_y[i]=posY+i*cellHeight+int(cellHeight/2);
	}	
}

PositionsBuffer::~PositionsBuffer()
{
	delete[] m_x;
	delete[] m_y;
}

Pos PositionsBuffer::getPixPos(int col, int line)
{
	if(col<0 || col>=m_nbCols || line<-3 || line>=m_nbLines)
		fatalError("PositionsBuffer::getPixPos : out of bounds: ("+toString(col)+","+toString(line)+")");
	Pos p(m_x[col], m_y[line+3]);
	return p;
}





