#include "code/game/combos/ComboCounter.h"
#include "code/game/gamedef.h"

ComboCounter::ComboCounter()
{
	m_combos=0;
	m_time=0;
	m_events=false;
}

ComboCounter::~ComboCounter()
{
	
}

bool ComboCounter::isHot()
{
	return m_combos>GAMEDEF_COMBO_IS_HOT;
}

void ComboCounter::update()
{
	if(m_time>0 && !m_events)
		m_time--;
}

void ComboCounter::notifyNewExplosions(bool force) //true pour forcer de le compter comme combo
{
	if(force || m_time>0)
	{
		m_combos++;
	}
	else
	{
		m_combos=1;
	}
	m_time=GAMEDEF_COMBO_TIME;
	m_events=true;
}

int ComboCounter::getCombos()
{
	if(!m_events && m_time<=0)
		return 0;
	
	return m_combos;
}

int ComboCounter::getTime()
{
	if(m_events)
		return 0;
	return m_time;
}

int ComboCounter::getTimeTotalAvailable()
{
	return GAMEDEF_COMBO_TIME;
}

bool ComboCounter::notifyEvents()
{
	if(!m_events)
	{
		m_events=true;
		return true;
	}
	return false;
}

bool ComboCounter::notifyNoEvents()
{
	if(m_events)
	{
		m_events=false;
		return true;
	}
	return false;
}

bool ComboCounter::isEvent()
{
	return m_events;
}

























