#ifndef LINEPATTERN_H_
#define LINEPATTERN_H_

#include <string>
#include <vector>
#include <list>
#include "code/game/pieces/abstract/AbstractPiece.h"

using namespace std;

//fourni les pièces qui apparaissent en bas du level
//il faut utiliser la méthode clone sur les pieces, et non les pieces elles-même
class LinePattern
{
	private:
		vector< list<AbstractPiece *> *> *m_pieces; //vecteur de listes de pieces
		unsigned int m_currentLineNum;
		int m_nbLoops;
		int m_currentLoop;
		
		AbstractPiece *getPieceFromString(string s, int linenum, int piecenum);
	
	public:
		LinePattern(string file, int nbLoops=-1);
		~LinePattern();
		//renvoie un tableau de pointeur de piece, ne pas le deleter, le destructeur de 
		//LinePattern le fait, ce n'est qu'une reference:
		//return NULL si il n'y a plus de ligne dispo
		list<AbstractPiece *> *getNextLine(); 
		int getNbLinesAvailable();
		void reset();
};

#endif /*LINEPATTERN_H_*/
