#include "code/game/levels/impl/mechanicalgroundwork/PDR4CMechaMCOContentCombo.h"
#include "code/framework/fx/EffectsLib.h"

PDR4CMechaMCOContentCombo::PDR4CMechaMCOContentCombo(Anim *explode_clone, Anim *shine_clone, OSL_IMAGE **numbers_units, OSL_IMAGE **numbers_tens, OSL_IMAGE *number_undefined, int nbCombos)
{
	m_anim_explode=explode_clone;
	m_anim_shine=shine_clone;
	m_img_combo_units=numbers_units;
	m_img_combo_tens=numbers_tens;
	m_img_combo_undefined=number_undefined;
	m_nbCombos=nbCombos;
	m_x=0;
	m_y=0;
	m_nbUnits=m_nbCombos%10;
	m_nbTens=int(m_nbCombos/10);
}

PDR4CMechaMCOContentCombo::~PDR4CMechaMCOContentCombo()
{
	delete m_anim_explode;
	delete m_anim_shine;
}

//drawable
void PDR4CMechaMCOContentCombo::draw(AbstractLocalEffect *fx1, AbstractLocalEffect *fx2, AbstractLocalEffect *fx3, AbstractLocalEffect *fx4, AbstractLocalEffect *fx5)
{
	if(m_anim_explode->isRunning())
	{
		m_anim_explode->drawXY(m_x, m_y);
	}
	else //!m_anim_explode->isRunning()
	{
		if(m_anim_shine->isRunning())
		{
			m_anim_shine->drawXY(m_x, m_y);
		}
		else
		{
			if(m_nbCombos<=59)
			{
				drawSimpleNumbers(m_x, m_y);
			}
			else //m_nbCombos >59
			{
				oslDrawImageXY(m_img_combo_undefined, m_x, m_y);
			}
		}
		
	}
}

void PDR4CMechaMCOContentCombo::drawXY(int x, int y, AbstractLocalEffect *fx1, AbstractLocalEffect *fx2, AbstractLocalEffect *fx3, AbstractLocalEffect *fx4, AbstractLocalEffect *fx5)
{
	if(m_anim_explode->isRunning())
	{
		fx::drawXY(m_anim_explode->getImage(),x,y,fx1,fx2,fx3,fx4,fx5);
	}
	else //!m_anim_explode->isRunning()
	{
		if(m_anim_shine->isRunning())
		{
			fx::drawXY(m_anim_shine->getImage(),x,y,fx1,fx2,fx3,fx4,fx5);
		}
		else
		{
			if(m_nbCombos<=59)
			{
				drawSimpleNumbers(x, y);
			}
			else //m_nbCombos >59
			{
				fx::drawXY(m_img_combo_undefined,x,y,fx1,fx2,fx3,fx4,fx5);
			}
		}
	}
}

void PDR4CMechaMCOContentCombo::drawSimpleNumbers(int x, int y)
{
	oslDrawImageXY(m_img_combo_tens[m_nbTens], x-10, y+10);
	oslDrawImageXY(m_img_combo_units[m_nbUnits], x-10+8, y+10);
}

//playable
void PDR4CMechaMCOContentCombo::update()
{
	m_anim_explode->update();
	m_anim_shine->update();
}

void PDR4CMechaMCOContentCombo::start()
{
	m_anim_explode->start();
}

void PDR4CMechaMCOContentCombo::stop()
{
	m_anim_explode->stop();
	m_anim_shine->stop();
}

void PDR4CMechaMCOContentCombo::reset()
{
	m_anim_explode->reset();
}

void PDR4CMechaMCOContentCombo::restart()
{
	m_anim_explode->restart();
}

bool PDR4CMechaMCOContentCombo::isRunning()
{
	return m_anim_explode->isRunning();
}


//positionable
void PDR4CMechaMCOContentCombo::setX(int x)
{
	m_x=x;
}

void PDR4CMechaMCOContentCombo::setY(int y)
{
	m_y=y;
}

int PDR4CMechaMCOContentCombo::getX()
{
	return m_x;
}

int PDR4CMechaMCOContentCombo::getY()
{
	return m_y;
}

State *PDR4CMechaMCOContentCombo::savestate(State * state)
{
	state->m_x=m_x;
	state->m_y=m_y;
	return state;
}

void PDR4CMechaMCOContentCombo::restorestate(State * state)
{
	m_x=state->m_x;
	m_y=state->m_y;
}

int PDR4CMechaMCOContentCombo::specialEvent(int event)
{
	if(event==PDR4C_LEVEL_MECHA_EVENT_COMBO_GETNB)
		return m_nbCombos;
	else if(event==PDR4C_LEVEL_MECHA_EVENT_COMBO_DECREMENT)
	{
		m_nbCombos--;
		m_anim_shine->restart();
		m_nbUnits=m_nbCombos%10;
		m_nbTens=int(m_nbCombos/10);
	}
	return 0;
}
