#ifndef PDR4CMECHAMCOCONTENTCOMBO_H_
#define PDR4CMECHAMCOCONTENTCOMBO_H_
#include "code/game/grid/AbstractMCOContent.h"
#include "code/framework/anim/Anim.h"
#include "code/framework/State.h"

#define PDR4C_LEVEL_MECHA_EVENT_COMBO_GETNB 1
#define PDR4C_LEVEL_MECHA_EVENT_COMBO_DECREMENT 2

class PDR4CMechaMCOContentCombo : public AbstractMCOContent
{
	private:
		Anim *m_anim_shine;
		Anim *m_anim_explode;
		OSL_IMAGE ** m_img_combo_units; //tableau de pointeurs, uniquement en référence, ne pas deleter
		OSL_IMAGE ** m_img_combo_tens; //tableau de pointeurs, uniquement en référence, ne pas deleter
		OSL_IMAGE * m_img_combo_undefined;
		
		int m_nbCombos;
		int m_x, m_y;
		int m_nbUnits, m_nbTens;
		
		void drawSimpleNumbers(int x, int y);
	
	public:
		PDR4CMechaMCOContentCombo(Anim *explode_clone, Anim *shine_clone, OSL_IMAGE **numbers_units, OSL_IMAGE **numbers_tens, OSL_IMAGE *number_undefined, int nbCombos);
		~PDR4CMechaMCOContentCombo();
		
		int specialEvent(int event);
		
		//drawable
		void draw(AbstractLocalEffect *fx1=NULL, AbstractLocalEffect *fx2=NULL, AbstractLocalEffect *fx3=NULL, AbstractLocalEffect *fx4=NULL, AbstractLocalEffect *fx5=NULL);
		void drawXY(int x, int y, AbstractLocalEffect *fx1=NULL, AbstractLocalEffect *fx2=NULL, AbstractLocalEffect *fx3=NULL, AbstractLocalEffect *fx4=NULL, AbstractLocalEffect *fx5=NULL);
		
		//playable
		void update();
		void start();
		void stop();
		void reset();
		void restart();
		bool isRunning();
		
		//positionable
		void setX(int x);
		void setY(int y);
		int getX();
		int getY();
		
		//statesaveable
		State *savestate(State * state);
		void restorestate(State * state);
};

#endif /*PDR4CMECHAMCOCONTENTCOMBO_H_*/
