#include "code/game/levels/impl/turnandburn/TurnAndBurnMCOContent.h"
#include "code/framework/particles/complete/fx/ParticlesProgressiveTintEffect.h"

TurnAndBurnMCOContent::TurnAndBurnMCOContent(ParticleGeneratorPoint *generator)
{
	//m_gen=new ParticleGeneratorPoint(0, 0, 0, 360, particles, frames, time, distance, time, "res/levels/turnandburn/smoke1.png", OSL_PF_4444, -1);
	//m_gen->setLocalEffect1SimpleTranslation();
	//m_gen->setGlobalEffect1(new ParticlesProgressiveTintEffect(time, 0, RGBA(255,255,0,255), RGBA(255,0,0,finalAlpha), 1));
	m_gen=generator;
}

TurnAndBurnMCOContent::~TurnAndBurnMCOContent()
{
	delete m_gen;
}

//drawable
void TurnAndBurnMCOContent::draw(AbstractLocalEffect *fx1, AbstractLocalEffect *fx2, AbstractLocalEffect *fx3, AbstractLocalEffect *fx4, AbstractLocalEffect *fx5)
{
	m_gen->draw(fx1, fx2, fx3, fx4, fx5);
}

void TurnAndBurnMCOContent::drawXY(int x, int y, AbstractLocalEffect *fx1, AbstractLocalEffect *fx2, AbstractLocalEffect *fx3, AbstractLocalEffect *fx4, AbstractLocalEffect *fx5)
{
	m_gen->drawXY(x, y, fx1, fx2, fx3, fx4, fx5);
}

//playable
void TurnAndBurnMCOContent::update()
{
	m_gen->update();
}

void TurnAndBurnMCOContent::start()
{
	m_gen->start();
}

void TurnAndBurnMCOContent::stop()
{
	m_gen->stop();
}

void TurnAndBurnMCOContent::reset()
{
	m_gen->reset();
}

void TurnAndBurnMCOContent::restart()
{
	m_gen->restart();
}

bool TurnAndBurnMCOContent::isRunning()
{
	return m_gen->isRunning();
}


//positionable
void TurnAndBurnMCOContent::setX(int x)
{
	m_gen->setX(x);
}

void TurnAndBurnMCOContent::setY(int y)
{
	m_gen->setY(y);
}

int TurnAndBurnMCOContent::getX()
{
	return m_gen->getX();
}

int TurnAndBurnMCOContent::getY()
{
	return m_gen->getY();
}

State *TurnAndBurnMCOContent::savestate(State * state)
{
	return m_gen->savestate(state);
}

void TurnAndBurnMCOContent::restorestate(State * state)
{
	m_gen->restorestate(state);
}

int TurnAndBurnMCOContent::specialEvent(int event)
{
	if(event==LEVEL_TURNANDBURN_MCO_EVENT_GENERATIONON)
	{
		m_gen->generationOn();
	}
	else if(event==LEVEL_TURNANDBURN_MCO_EVENT_GENERATIONOFF)
	{
		m_gen->generationOff();
	}
	else if(event==LEVEL_TURNANDBURN_MCO_EVENT_GETNBPARTICLES)
	{
		return m_gen->getCurrentNbParticles();
	}
	return 0;
}
