#ifndef TURNANDBURNMCOCONTENT_H_
#define TURNANDBURNMCOCONTENT_H_

#include "code/game/grid/AbstractMCOContent.h"
#include "code/framework/particles/complete/impl/ParticleGeneratorPoint.h"
#include "code/framework/State.h"

#define LEVEL_TURNANDBURN_MCO_EVENT_GENERATIONON 1
#define LEVEL_TURNANDBURN_MCO_EVENT_GENERATIONOFF 2
#define LEVEL_TURNANDBURN_MCO_EVENT_GETNBPARTICLES 3

class TurnAndBurnMCOContent : public AbstractMCOContent
{
	private:
		ParticleGeneratorPoint *m_gen;
	
	public:
		TurnAndBurnMCOContent(ParticleGeneratorPoint *generator);
		~TurnAndBurnMCOContent();
		
		int specialEvent(int event);
		
		//drawable
		void draw(AbstractLocalEffect *fx1=NULL, AbstractLocalEffect *fx2=NULL, AbstractLocalEffect *fx3=NULL, AbstractLocalEffect *fx4=NULL, AbstractLocalEffect *fx5=NULL);
		void drawXY(int x, int y, AbstractLocalEffect *fx1=NULL, AbstractLocalEffect *fx2=NULL, AbstractLocalEffect *fx3=NULL, AbstractLocalEffect *fx4=NULL, AbstractLocalEffect *fx5=NULL);
		
		//playable
		void update();
		void start();
		void stop();
		void reset();
		void restart();
		bool isRunning();
		
		//positionable
		void setX(int x);
		void setY(int y);
		int getX();
		int getY();
		
		//statesaveable
		State *savestate(State * state);
		void restorestate(State * state);
};

#endif /*TURNANDBURNMCOCONTENT_H_*/
