#ifndef CONDEMEDPARTICLEGENERATORPOINT_H_
#define CONDEMEDPARTICLEGENERATORPOINT_H_

#include <string>
#include "code/framework/particles/complete/impl/ParticleGeneratorPoint.h"
#include "code/game/levels/impl/underwater/CondemnedObject.h"

using namespace std;

/**
 *  un generateur de particule tout simple avec en + un marqueur "condamné" afin qu'il soit détruit
 * 	dès qu'il est condamné et n'a plus de particules.
 */
class CondemnedParticleGeneratorPoint: public ParticleGeneratorPoint, public CondemnedObject
{
	private:
	
	public:
		CondemnedParticleGeneratorPoint(	int x, int y, int direction, int scale, int nbParticles, int generationTime, int movingTime, 
									int dist, int particleLifespan, AbstractAnimationFactory *animFactory, int nbLoops=-1);
		CondemnedParticleGeneratorPoint(	int x, int y, int direction, int scale, int nbParticles, int generationTime, int movingTime, int dist, 
								int particleLifespan, Anim *anim, int nbLoops=-1);
		CondemnedParticleGeneratorPoint(	int x, int y, int direction, int scale, int nbParticles, int generationTime, int movingTime, int dist,
								int particleLifespan, string filename, short transparency, int nbLoops=-1);
		
		~CondemnedParticleGeneratorPoint();
		
		bool mustBeDestroyed();
		
		virtual CondemnedParticleGeneratorPoint *clone() const;
};

#endif /*CONDEMEDPARTICLEGENERATOR_H_*/
