#ifndef MCOCONTENTCOMBOBUBBLES_H_
#define MCOCONTENTCOMBOBUBBLES_H_

#include "code/game/grid/AbstractMCOContent.h"
#include "code/game/levels/utils/MCOContentCombo.h"
#include "code/game/levels/impl/underwater/CondemnedParticleGeneratorPoint.h"

class MCOContentComboBubbles : public AbstractMCOContent
{
	private:
		MCOContentCombo *m_mcoc_combo;
		CondemnedParticleGeneratorPoint *m_gen_bubbles_constant;
		CondemnedParticleGeneratorPoint *m_gen_bubbles_combos;
		CondemnedParticleGeneratorPoint *m_gen_bubbles_explode;
		
	
	public:
		MCOContentComboBubbles(MCOContentCombo *mcocc, CondemnedParticleGeneratorPoint* bubbles_constant, CondemnedParticleGeneratorPoint* bubbles_combos, CondemnedParticleGeneratorPoint* bubbles_explode);
		~MCOContentComboBubbles();
		
		int specialEvent(int event);
		
		//drawable
		void draw(AbstractLocalEffect *fx1=NULL, AbstractLocalEffect *fx2=NULL, AbstractLocalEffect *fx3=NULL, AbstractLocalEffect *fx4=NULL, AbstractLocalEffect *fx5=NULL);
		void drawXY(int x, int y, AbstractLocalEffect *fx1=NULL, AbstractLocalEffect *fx2=NULL, AbstractLocalEffect *fx3=NULL, AbstractLocalEffect *fx4=NULL, AbstractLocalEffect *fx5=NULL);
		
		//playable
		void update();
		void start();
		void stop();
		void reset();
		void restart();
		bool isRunning();
		
		//positionable
		void setX(int x);
		void setY(int y);
		int getX();
		int getY();
		
		//statesaveable
		State *savestate(State * state);
		void restorestate(State * state);
		
};

#endif /*MCOCONTENTCOMBOBUBBLES_H_*/
