#ifndef ANIMALPROPERTIES_H_
#define ANIMALPROPERTIES_H_

#include "code/framework/anim/Anim.h"

class AnimalProperties
{
	private:
		//suivant la taille il doit commencer + ou - loin du bord
		int m_x_left;
		int m_x_right;
		
		//la profondeur min et max ou il a le droit d'apparaitre
		int m_y_min;
		int m_y_max;
		
		//vitesse de déplacement
		int m_transl_time_min;
		int m_transl_time_max;
		
		Anim *m_anim;
		
		//proportion d'apparition
		int m_spawn_proportion;
		
		//taille minimum en %
		int m_size_minimum_percent;
	
	public:
		AnimalProperties(int xleft, int xright, int ymin, int ymax, int translmin, int translmax, Anim *animref, int spawnproportion, int sizemin);
		~AnimalProperties();
		
		int getXLeft();
		int getXRight();
		int getYMin();
		int getYMax();
		int getTranslationTimeMin();
		int getTranslationTimeMax();
		int getMaxReductionPercent();
		
		Anim *getAnimClone();
		
		int getSpawnProportion();
};

#endif /*ANIMALPROPERTIES_H_*/
