#ifndef DJMCOCONTENTLAYERED_H_
#define DJMCOCONTENTLAYERED_H_

#include "code/game/grid/AbstractMCOContent.h"
#include "code/framework/anim/Anim.h"
#include "code/framework/State.h"
#include <oslib/oslib.h>
#include <vector>

using namespace std;

class DJMCOContentLayered : public AbstractMCOContent
{
	private:
		//les couches qd la piece n'explose pas
		vector<Anim *> *m_layers_normal;
		vector<bool> *m_colorized_normal;
		
		//les couches quand la piece explose
		vector<Anim *> *m_layers_explosion;
		vector<bool> *m_colorized_explosion;
	
		int m_color;
		//besoin pour melange de couleurs
		OSL_ALPHA_PARAMS *m_alpha;
		u8 * m_curColor;
		u8 * m_newColor;
		int *m_color_comp; //utilisé pour tinter la piece avant dessin
		
		bool m_exploding;
		int m_x;
		int m_y;
	
	public:
		DJMCOContentLayered(OSL_COLOR color=0);
		~DJMCOContentLayered();
		
		int specialEvent(int event);
		
		OSL_COLOR getColor();
		void setColor(OSL_COLOR color);
		bool isExploding();
		
		Anim * addLayer(Anim *aclone, bool colorized=true);
		Anim * addLayerExplosion(Anim *aclone, bool colorized=true);
		
		
		//drawable
		void draw(AbstractLocalEffect *fx1=NULL, AbstractLocalEffect *fx2=NULL, AbstractLocalEffect *fx3=NULL, AbstractLocalEffect *fx4=NULL, AbstractLocalEffect *fx5=NULL);
		void drawXY(int x, int y, AbstractLocalEffect *fx1=NULL, AbstractLocalEffect *fx2=NULL, AbstractLocalEffect *fx3=NULL, AbstractLocalEffect *fx4=NULL, AbstractLocalEffect *fx5=NULL);
		
		//playable
		void update();
		void start();
		void stop();
		void reset();
		void restart();
		bool isRunning();
		
		//positionable
		void setX(int x);
		void setY(int y);
		int getX();
		int getY();
		
		//statesaveable
		State *savestate(State * state);
		void restorestate(State * state);
};

#endif /*DJMCOCONTENTLAYERED_H_*/
