#ifndef DJMCOCONTENTSIMPLE_H_
#define DJMCOCONTENTSIMPLE_H_

#include "code/game/grid/AbstractMCOContent.h"
#include "code/framework/anim/Anim.h"
#include "code/framework/State.h"
#include <oslib/oslib.h>

class DJMCOContentSimple : public AbstractMCOContent
{
	private:
		Anim *m_anim;
		int m_color;
		//besoin pour melange de couleurs
		OSL_ALPHA_PARAMS *m_alpha;
		u8 * m_curColor;
		u8 * m_newColor;
		int *m_color_comp; //utilisé pour tinter la piece avant dessin
	
	
	public:
		DJMCOContentSimple(Anim *aclone, OSL_COLOR color);
		~DJMCOContentSimple();
		
		int specialEvent(int event);
		Anim *getAnim();
		
		OSL_COLOR getColor();
		void setColor(OSL_COLOR color);
		
		
		//drawable
		void draw(AbstractLocalEffect *fx1=NULL, AbstractLocalEffect *fx2=NULL, AbstractLocalEffect *fx3=NULL, AbstractLocalEffect *fx4=NULL, AbstractLocalEffect *fx5=NULL);
		void drawXY(int x, int y, AbstractLocalEffect *fx1=NULL, AbstractLocalEffect *fx2=NULL, AbstractLocalEffect *fx3=NULL, AbstractLocalEffect *fx4=NULL, AbstractLocalEffect *fx5=NULL);
		
		//playable
		void update();
		void start();
		void stop();
		void reset();
		void restart();
		bool isRunning();
		
		//positionable
		void setX(int x);
		void setY(int y);
		int getX();
		int getY();
		
		//statesaveable
		State *savestate(State * state);
		void restorestate(State * state);
};

#endif /*DJMCOCONTENTSIMPLE_H_*/
