#include "code/game/levels/utils/MCOContentFlagged.h"

MCOContentFlagged::MCOContentFlagged(AbstractMCOContent *mcoc)
{
	m_mcoc=mcoc;
	m_flagged=false;
}

MCOContentFlagged::~MCOContentFlagged()
{
	delete m_mcoc;
}

int MCOContentFlagged::specialEvent(int event)
{
	if(event==MCOCONTENT_EVENT_SET_FLAG_TRUE)
	{
		setFlag(true);
	}
	else if(event==MCOCONTENT_EVENT_SET_FLAG_FALSE)
	{
		setFlag(false);
	}
	else if(event==MCOCONTENT_EVENT_ISFLAGGED)
	{
		return m_flagged?1:0;
	}
	
	//else
	
	return m_mcoc->specialEvent(event);
}	

//drawable
void MCOContentFlagged::draw(AbstractLocalEffect *fx1, AbstractLocalEffect *fx2, AbstractLocalEffect *fx3, AbstractLocalEffect *fx4, AbstractLocalEffect *fx5)
{
	m_mcoc->draw(fx1, fx2, fx3, fx4, fx5);
}

void MCOContentFlagged::drawXY(int x, int y, AbstractLocalEffect *fx1, AbstractLocalEffect *fx2, AbstractLocalEffect *fx3, AbstractLocalEffect *fx4, AbstractLocalEffect *fx5)
{
	m_mcoc->drawXY(x, y, fx1, fx2, fx3, fx4, fx5);
}


bool MCOContentFlagged::isFlagged()
{
	return m_flagged;
}

void MCOContentFlagged::setFlag(bool flag)
{
	m_flagged=flag;
}
		
//playable
void MCOContentFlagged::update()
{
	m_mcoc->update();
}	

void MCOContentFlagged::start()
{
	m_mcoc->start();
}	

void MCOContentFlagged::stop()
{
	m_mcoc->stop();
}	

void MCOContentFlagged::reset()
{
	m_mcoc->reset();
}	

void MCOContentFlagged::restart()
{
	m_mcoc->restart();
}	

bool MCOContentFlagged::isRunning()
{
	return m_mcoc->isRunning();
}	

//positionable
void MCOContentFlagged::setX(int x)
{
	m_mcoc->setX(x);
}	

void MCOContentFlagged::setY(int y)
{
	m_mcoc->setY(y);
}	

int MCOContentFlagged::getX()
{
	return m_mcoc->getX();
}	

int MCOContentFlagged::getY()
{
	return m_mcoc->getY();
}	

//statesaveable
State *MCOContentFlagged::savestate(State * state)
{
	return m_mcoc->savestate(state);
}

void MCOContentFlagged::restorestate(State * state)
{
	m_mcoc->restorestate(state);
}

		
		