#ifndef MCOCONTENTSIMPLE_H_
#define MCOCONTENTSIMPLE_H_

#include "code/game/grid/AbstractMCOContent.h"
#include "code/framework/anim/Anim.h"
#include "code/framework/State.h"
#include "code/game/levels/utils/MCOContentEvents.h"

class MCOContentSimple : public AbstractMCOContent
{
	private:
		Anim *m_anim;
	
	public:
		MCOContentSimple(Anim *aclone);
		~MCOContentSimple();
		
		int specialEvent(int event);
		Anim *getAnim();
		
		//drawable
		void draw(AbstractLocalEffect *fx1=NULL, AbstractLocalEffect *fx2=NULL, AbstractLocalEffect *fx3=NULL, AbstractLocalEffect *fx4=NULL, AbstractLocalEffect *fx5=NULL);
		void drawXY(int x, int y, AbstractLocalEffect *fx1=NULL, AbstractLocalEffect *fx2=NULL, AbstractLocalEffect *fx3=NULL, AbstractLocalEffect *fx4=NULL, AbstractLocalEffect *fx5=NULL);
		
		//playable
		void update();
		void start();
		void stop();
		void reset();
		void restart();
		bool isRunning();
		
		//positionable
		void setX(int x);
		void setY(int y);
		int getX();
		int getY();
		
		//statesaveable
		State *savestate(State * state);
		void restorestate(State * state);
};

#endif /*MCOCONTENTSIMPLE_H_*/
