#include "code/game/loading/loading.h"
#include <oslib/oslib.h>
#include <string>
#include <pspthreadman.h>
#include "code/framework/utils.h"
#include "code/framework/fx/EffectsLib.h"
//#include "code/framework/semaphores.h" 
#include <pspsdk.h>
#include "code/framework/utils.h"

using namespace utils;
using namespace std;

/*
SceUID Loading::thid_;
LoadingRes* Loading::res_;
char Loading::startPath_[MAX_PATH];
*/

Loading::Loading() 
{
	//getcwd(m_startPath, MAX_PATH);
	m_res=new LoadingRes();

   	// The loadingscreen is loaded as a thread
   	m_thid = sceKernelCreateThread("LoadingThread", staticRunLoading, 0x11, 256*1024, PSP_THREAD_ATTR_VFPU|PSP_THREAD_ATTR_USER, NULL);

   	// Start the thread
   	//sceKernelStartThread(m_thid, 0, 0);
}

Loading::~Loading()
{
	while(m_res->m_timer->getTime()<4000)
	{
		oslWaitVSync();
	}
	oslWaitVSync();
   	// shut down the loading screen
   	int ret=sceKernelTerminateDeleteThread(m_thid);
   	oslEndFrame();
    oslSyncFrame();
   	if (ret < 0)
	{
		fatalError("cannot terminate thread!");
	}  
   	
   	delete m_res;
}



void Loading::go(Loading *loading)
{
	// Start the thread
	sceKernelStartThread(loading->m_thid, sizeof(loading), &loading);
}

void Loading::start()
{
	go(this);
}


//static
int Loading::staticRunLoading(SceSize args, void *argp)
{
	Loading *_this = *((Loading**) argp);
	_this->runLoading();
	
	return 0;
}

int Loading::runLoading()
{
	//chdir(m_startPath);
	
	bool m_skip=false;
	int i=0;
	
	m_res->m_pws->start();
	m_res->m_fx_scrcpy_grav->start();
	m_res->m_fx_scrcpy_shrink->start();
	m_res->m_fx_vinyl_rot->start();
	m_res->m_fx_bg_tint->start();
	m_res->m_fx_L->start();
	m_res->m_fx_o->start();
	m_res->m_fx_a->start();
	m_res->m_fx_d->start();
	m_res->m_fx_i->start();
	m_res->m_fx_n->start();
	m_res->m_fx_g->start();
	
	while(!osl_quit)
	{		
		//phase d'update
		m_res->m_pws->update();
		m_res->m_fx_scrcpy_grav->update();
		m_res->m_fx_scrcpy_shrink->update();
		m_res->m_fx_vinyl_rot->update();
		m_res->m_fx_bg_tint->update();
		m_res->m_fx_L->update();
		m_res->m_fx_o->update();
		m_res->m_fx_a->update();
		m_res->m_fx_d->update();
		m_res->m_fx_i->update();
		m_res->m_fx_n->update();
		m_res->m_fx_g->update();
		
		if (!m_skip)
		{
			//phase de dessin			
			oslStartDrawing();
			
			AlphaParamsState * alpha=new AlphaParamsState();
			alpha->saveState();
			m_res->m_fx_bg_tint->activate();			
			oslDrawImageXY(m_res->m_img_bg,0,0);
			alpha->restoreState();
			delete alpha;
			
			oslDrawImageXY(m_res->m_img_djdrops,33,32);
			
			fx::drawXY(m_res->m_img_vinyl, 325, 107, m_res->m_fx_vinyl_rot); 
			
			//dessin de "Loading"
			int x=180,y=200; //départ de l'écriture
			fx::drawXY(m_res->m_img_L,x,y-4,m_res->m_fx_L);
			x+=24;
			fx::drawXY(m_res->m_img_o,x,y,m_res->m_fx_o);
			x+=24;
			fx::drawXY(m_res->m_img_a,x,y,m_res->m_fx_a);
			x+=24;
			fx::drawXY(m_res->m_img_d,x,y-4,m_res->m_fx_d);
			x+=18;
			fx::drawXY(m_res->m_img_i,x,y-3,m_res->m_fx_i);
			x+=18;
			fx::drawXY(m_res->m_img_n,x,y,m_res->m_fx_n);
			x+=24;
			fx::drawXY(m_res->m_img_g,x,y+5,m_res->m_fx_g);
			
			fx::drawXY(m_res->m_img_screencpy, 0, 0, m_res->m_fx_scrcpy_grav, m_res->m_fx_scrcpy_shrink);
			
			oslEndDrawing();
			
		}
		
		//End of a frame
        oslEndFrame();
		//Synchronize to ensure the game runs at 60 fps
        m_skip = oslSyncFrame();
		//oslAudioVSync(); //ne sert plus, oslEndFrame le fait
		i++;
	}
	
	return 0;
}















