#ifndef MAINMENU_H_
#define MAINMENU_H_
#include <string>
#include <oslib/oslib.h>
#include "code/framework/anim/Anim.h"
#include "code/framework/bmpFont/BmpFont.h"
#include "code/framework/bmpFont/BmpText.h"
#include "code/framework/fx/EffectsLib.h"
#include "code/game/menus/MenuItemManager.h"
#include "code/game/EventsScenario.h"
//#include "code/framework/sound/ChannelDistributor.h"
#include "code/framework/sound/ChannelManager.h"
#include "code/game/menus/Explosion.h"
//#include "code/framework/particles/complete/abstract/AbstractParticleGenerator.h"
#include "code/framework/particles/complete/impl/ParticleGeneratorPoint.h"

using namespace std;


class MainMenu
{
	private:
		//fonctionnement
		string m_locale;
		bool m_skip;
		int m_action;
	
		//ressources
		Anim *m_anim_projecteur;
	
		OSL_IMAGE * m_img_bg;
		OSL_IMAGE * m_img_ray;
		OSL_IMAGE * m_img_djdrops;
		OSL_IMAGE * m_img_vinyl;
		
		OSL_IMAGE * m_img_attention;
		OSL_IMAGE * m_img_interdit;
	
		//sons pour actions
		OSL_SOUND * m_snd_move;
		OSL_SOUND * m_snd_cancel;
		OSL_SOUND * m_snd_select;
		
		//effets
		SimpleEffectManager *		m_fxmgr_effects;
		SizeWowEffect *				m_fx_swow;
		SizeWowEffect *				m_fx_swowprojhor;
		SizeWowEffect *				m_fx_swowprojvert;
		ProgressiveTintEffect *		m_fx_ptint;
		ProgressiveTintEffect *		m_fx_ptint3;
		SerialGlobalEffect *		m_fx_bg;
		RotationEffect *			m_fx_vinyl;
		SerialLocalEffect *			m_fx_ray_gh;
		SerialLocalEffect *			m_fx_ray_gb;
		SerialLocalEffect *			m_fx_ray_dh;
		SerialLocalEffect *			m_fx_ray_db;
	
		SimpleEffectManager *		m_fxmgr_scenario;
		ShakeEffect *m_fx_smallshake;
		ShakeEffect *m_fx_shake;
		ShakeEffect *m_fx_bigshake;
		ProgressiveAlphaEffect *m_fx_bgtext_attention_appear;
		ProgressiveAlphaEffect *m_fx_bgtext_interdit_appear;
		SizeWowEffect *m_fx_bgtexts_grow;
		SizeWowEffect *m_fx_vinyl_grow;

	
		//fonctions membres
		void drawScene();
		int keys();
		void initBgTextImages(BmpFont *f);
		
		
		MenuItemManager *m_menu;
		
		//ChannelDistributor *m_channel;
		ChannelManager *m_chan_mgr;
		
		Explosion *m_explosion;
		
		bool m_projectors_on;
		
		//beaux effets sur le disque quand il grossit
		ParticleGeneratorPoint *m_gen_vinyl1;
		ParticleGeneratorPoint *m_gen_vinyl2;
		
		//tests
		//OSL_IMAGE * m_bmpt_test;
		//AppearDownEffect *			m_fx_test;
		//AbstractParticleGenerator * m_test_partGen;
		//ShakeEffect * m_test_fx_shakePartGen;
		//State * m_test_partGenState;
		
		
			
	public:
		int go(bool debugmode=false);
		MainMenu(string locale);
		~MainMenu();
		
		//musique & sons + scenario
		//obligé de mettre en static pour les passer au callback
		static OSL_SOUND* m_music;
		static EventsScenario *m_scenario;
		static int musicCallBackFunction(OSL_SOUND *s, int voice);
		
};





#endif /*MAINMENU_H_*/











