#ifndef QJMAINMENU_H_
#define QJMAINMENU_H_
#include <string>
#include <oslib/oslib.h>
#include "code/framework/anim/Anim.h"
#include "code/framework/bmpFont/BmpFont.h"
#include "code/framework/bmpFont/BmpText.h"
#include "code/framework/fx/EffectsLib.h"
#include "code/game/menus/qj/QJMenuItemManager.h"
//#include "code/framework/sound/ChannelDistributor.h"
#include "code/framework/sound/ChannelManager.h"
#include "code/framework/time/Timer.h"

using namespace std;


class QJMainMenu
{
	private:
		//fonctionnement
		string m_locale;
		bool m_skip;
		int m_action;
		
		OSL_SOUND* m_music;
		
		//sons pour actions
		OSL_SOUND * m_snd_move;
		OSL_SOUND * m_snd_cancel;
		OSL_SOUND * m_snd_select;
			
		//fonctions membres
		void drawScene();
		int keys();
		
		QJMenuItemManager *m_menu;
		
		ChannelManager *m_chan_mgr;
		
		ProgressiveAlphaEffect *m_fx_scene_appear;
		SerialGlobalEffect *m_fx_bg_transition;
		OSL_IMAGE *m_img_bg1;
		OSL_IMAGE *m_img_bg2;
		
		//au bout d'un moment, tout disparait lentement
		SerialGlobalEffect *m_fx_disappearall;
		
		OSL_IMAGE *m_img_title;
		
			
	public:
		int go(bool debugmode=false);
		QJMainMenu(string locale);
		~QJMainMenu();
				
};





#endif /*QJMAINMENU_H_*/











