#ifndef PIECESBUFFERFACTORY_H_
#define PIECESBUFFERFACTORY_H_
#include "code/framework/anim/Anim.h"
#include <vector>
#include <oslib/oslib.h>


//va mettre en buffer toutes les anims possibles et fabriquer
//des copies à la demande. permet de garder en buffer toutes les
//images.
class PiecesBufferFactory
{
	private :
		PiecesBufferFactory(); //do not instanciate
		static vector<Anim *> *m_pieceDestrAnim; //TODO: ca devrait être un tableau plutôt
		static OSL_IMAGE **m_comboNumbers; //tableau de pointeurs, pour piece "combo"
		static Anim *m_comboShine; //animation qui fait briller les pieces combo a chaque changement
		static OSL_IMAGE **m_shieldedImages; //tableau de pointeurs, pour pieces shielded
		static OSL_IMAGE *m_joker1;
		static OSL_IMAGE *m_joker2;	
		
		static bool m_isBuffered;
		
		static int m_combo_image_number;
		
	public:
		 
		//~AnimBufferFactory(); 
		
		static void bufferResources();
		static void unbufferResources();
		static Anim *newPieceDestrAnim(int shape);
		static Anim *newComboDestrAnim();
		static OSL_IMAGE *getComboImage(int number);
		static Anim *newComboShineAnim();
		static OSL_IMAGE *getShieldedImage(int shape);
		static OSL_IMAGE *getJokerImage1();
		static OSL_IMAGE *getJokerImage2();
		
		//monitoring et tests
		static int getNbAnims(); //attention si pointeur non initialisé
		
		
};



#endif /*PIECESBUFFERFACTORY_H_*/







