#ifndef PIECELEVEL_H_
#define PIECELEVEL_H_

#include "code/game/pieces/abstract/AbstractPiece.h"
#include "code/framework/time/Repeater.h"


//piece qui n'est pas gérée par le moteur du jeu, mais par le level
class PieceLevel : public AbstractPiece
{
	
	private:
		int m_color_num;
		int m_shape_num;
		int m_id;
		bool m_random;
		Repeater *m_repeater;
		
	
	public:
		PieceLevel(int shape, int color, int id=0);
		PieceLevel(int id=0);
		~PieceLevel();
		PieceLevel(const PieceLevel &piece);//copie
   		PieceLevel& operator =(const PieceLevel& piece);
   		
   		PieceLevel * clone() const;
   		   		
   		int getShape(); //shapenum
		int getColor(); //colornum
		int getType(); //typenum
		void setColor(int color);
		void setShape(int shape);
		
		void startDestruct(); //demarre l'anim de destruction
		void drawXY(int x, int y, AbstractLocalEffect *fx1=NULL, AbstractLocalEffect *fx2=NULL, AbstractLocalEffect *fx3=NULL, AbstractLocalEffect *fx4=NULL, AbstractLocalEffect *fx5=NULL);
		void update(); 
		bool destructed(); //informe de la fin de l'anim d'explosion
		bool destructing(); //informe qu'elle est en train d'exploser
				
		bool isRandom();
		
		int specialEvent(int e); //get id est la dedans
   		void setId(int id);
   		
   		void setExplosionTime(float time);
};

#endif /*PIECELEVEL_H_*/
