#ifndef PIECESIMPLE_H_
#define PIECESIMPLE_H_

#include "code/game/pieces/abstract/AbstractPiece.h"
#include <oslib/oslib.h>
#include "code/framework/anim/Anim.h"
//#include "code/framework/check/Trackable.h"

class PieceSimple : public AbstractPiece//, public Trackable
{
	protected:
		int m_color_num;
		int m_shape_num;
		OSL_COLOR m_color; //utilisé pour tinter la piece avant dessin
		int *m_color_comp; //utilisé pour tinter la piece avant dessin
		
		Anim *m_anim_destr;
		bool m_random;
		
		//besoin pour melange de couleurs
		OSL_ALPHA_PARAMS *m_alpha;
		u8 * m_curColor;
		u8 * m_newColor;
		
			
	public:
		PieceSimple(int shape, int color);
		PieceSimple(); //aléatoire
		virtual ~PieceSimple();
		PieceSimple(const PieceSimple &piece);//copie
   		PieceSimple& operator =(const PieceSimple& piece);
   		
   		virtual PieceSimple * clone() const;
   		
		int getShape(); //shapenum
		int getColor(); //colornum
		virtual int getType(); //typenum
		virtual void setColor(int color);
		virtual void setShape(int shape);
		
		virtual void startDestruct(); //demarre l'anim de destruction
		virtual void drawXY(int x, int y, AbstractLocalEffect *fx1=NULL, AbstractLocalEffect *fx2=NULL, AbstractLocalEffect *fx3=NULL, AbstractLocalEffect *fx4=NULL, AbstractLocalEffect *fx5=NULL);
		virtual void update(); 
		bool destructed(); //informe de la fin de l'anim d'explosion
		bool destructing(); //informe qu'elle est en train d'exploser
		
		virtual int specialEvent(int e){return 0;}
		
		bool isRandom();
		
		void setExplosionTime(float time);
		
};

#endif /*PIECESIMPLE_H_*/
