#ifndef SCORER_H_
#define SCORER_H_

#include <string>
#include "code/game/grid/GridEventResult.h"

using namespace std;

#define SCORE_POINTS_FASTDROP_PERFRAME 0.1f
#define SCORE_POINTS_SIMPLE_EXPLOSION 10
#define SCORE_POINTS_CONTACT_EXPLOSION 4
#define SCORE_POINTS_COMBO_MULTIPLIER 0.2f
#define SCORE_POINTS_JOKER_EXPLOSION 3
#define SCORE_POINTS_COMBO_EXPLOSION 10
#define SCORE_POINTS_COMBO_DECREMENT 2
#define SCORE_POINTS_SPECIAL_EXPLOSION 7


//pour un level donné, va calculer le score et contenir toutes
//les infos nécessaires: meilleur score (tous et sien), meilleur
//combos (tous et sien) score actuel meilleur combo actuel, nom
//du meilleur etc...
class Scorer
{
	private:
		float m_score_current;
		int m_score_best_self;
		
		int m_maxcombos_current;
		int m_maxcombos_best_self;
		
		void updateBest(); //met a jour au cas ou le score ou les combos du best sont battus
		bool m_did_best_combos;
		bool m_did_best_score;
	
	public:
		Scorer(string levelcode, int difficulty);
		~Scorer();
		
		int getScoreCurrent();
		int getScoreBestSelf();
		
		int getMaxcombosCurrent();
		int getMaxcombosBestSelf();
		
		void notifyFastdropFrame();
		void notifyExplosions(GridEventResult ger, int nbCombos);
		void notifyComboExplosions(int nbExpl, int nbCombos);
		void notifyComboDecrements(int nbExpl, int nbCombos);
		void notifyComboNumber(int nb);
	
		bool isBestCombos();
		bool isBestScore();
	
};

#endif /*SCORER_H_*/
