#include <stdio.h>
#include <string>
#include <sstream>
#include <vector>
#include <list>

#include "code/game/gamedef.h"

#include "code/framework/anim/Anim.h"

#include "code/framework/bmpFont/BmpFont.h"
#include "code/framework/resRepo/ResRepoFactory.h"

#include <oslib/oslib.h>
#include "code/game/settings.h"
#include "code/framework/utils.h"
#include "code/framework/pspcallbacks.h"

#include "code/framework/bmpFont/BmpFont.h"
#include "code/framework/bmpFont/BmpText.h"
#include "code/framework/fx/EffectsLib.h"
#include "code/framework/fx/utils/ImgState.h"
#include "code/game/menus/MainMenu.h"
#include "code/game/menus/SoloGame.h"

using namespace std; 
using namespace utils;

#include "code/tests/TestScenario.h"
#include "code/tests/TestLevelEditor.h"

#include "code/game/menus/Logo.h"
#include "code/game/menus/ShowImage.h"
#include "code/framework/check/PrettyFileLogger.h"

//#include "code/game/loading/Loading.h"

//TODO: enlever ca c'etait pour des tests
#include "code/game/levels/LevelFactory.h"
#include "code/game/menus/qj/dialogs/LevelRecordsDialog.h"
#include "code/game/grid/GameGrid.h"
#include "code/game/combos/ComboCounter.h"
#include "code/game/Pair.h"
#include "code/game/pieces/impl/PieceSimple.h"
#include "code/game/grid/MatrixContentObject.h"
#include "code/game/FlagMatrix.h"
#include "code/framework/check/MemoryWatcher.h"
#include "code/game/pieces/impl/PieceCombo.h"
#include "code/game/saves/GameSave.h"
#include "code/game/SongBanner.h"
#include "code/game/sound/PleaseWaitSound.h"
//#include "code/game/loading/LoadingRes.h"
#include "code/framework/imgFilters/imgFilters.h"
#include "code/game/menus/qj/dialogs/LevelRecordsDialog.h"
#include "code/game/menus/qj/dialogs/YouLooseDialog.h"
#include "code/game/menus/qj/dialogs/YouWinDialog.h"
#include <iostream>

#define THREAD_ATTR_KERNEL 0x1000

PSP_MODULE_INFO("djdrops", 0, 1, 1);
PSP_MAIN_THREAD_ATTR(THREAD_ATTR_USER | THREAD_ATTR_VFPU);

PSP_MAIN_THREAD_STACK_SIZE_KB(1024);//1024 ok, mais trop enorme, TODO: a voir s'il faut pas reduire!

//PSP_HEAP_SIZE_KB(20*1024);  //ca ok 20*1024, ca a l'air de marcher mieux que -1024
PSP_HEAP_SIZE_KB(20*1024);
//PSP_HEAP_SIZE_MAX(); //marche pas fait planter le son puis pouf le thread principal
//PSP_HEAP_SIZE_KB(24*1024);
//PSP_HEAP_SIZE_KB(-1024); 

//PSP_HEAP_SIZE_MAX();
//__psp_free_heap();
//__psp_heap_blockid;

//sceKernelTotalFreeMemSize 
//where as the heap is shared between all threads

int main(int argc, char* argv[])
{	
	SetupCallbacks();
	init();
		
	string locale="en";
	int endroit=LOGO_SEQUENCE;
	int endroit_old=endroit;
	
	//struct mallinfo mi1,mi2;
	/////TEST MEMOIRE MAIN MENU
	/*
	 * 
	mi1=mallinfo();
	//------
	MainMenu *maintestmem=new MainMenu(locale);
	delete maintestmem;
	//------
	mi2=mallinfo();
	message("memory lost: "+toString(mi1.fordblks - mi2.fordblks));
	*/
	MemoryWatcher memw_main;
	
	
	//test couleur:
	/*int rgb[3]={175,87,54};
	float hsl[3]={0.0f,0.0f,0.0f};
	
	rgbToHsl(rgb, hsl);
	message("hsl = "+toString(hsl[0])+","+toString(hsl[1])+","+toString(hsl[2]));
	hslToRgb(hsl, rgb);
	message("rgb = "+toString(rgb[0])+","+toString(rgb[1])+","+toString(rgb[2]));
	*/
	//message("le bon code est au boulot et sur la psp");
	//c'est pas ca:
	/*LevelRecordsDialog *lrdialog=new LevelRecordsDialog("sexy", GAMEDEF_DIFFICULTY_EASY);
	lrdialog->go();
	delete lrdialog;
	*/
	/*
	memw_main.memorySnapshotStart();
	YouLooseDialog *loosedialog=new YouLooseDialog(320000.0f, 150000.0f);
	loosedialog->go();
	delete loosedialog;
	memw_main.memorySnapshotEnd();
	message("loosedialog memory lost: "+toString(memw_main.getMemoryLostType1())+" or "+toString(memw_main.getMemoryLostType2())+" or "+toString(memw_main.getMemoryLostType3()));
	
	
	memw_main.memorySnapshotStart();
	YouWinDialog *windialog=new YouWinDialog("sexy", GAMEDEF_DIFFICULTY_EASY, 25000, 15, 15000, 45);
	windialog->go();
	delete windialog;
	memw_main.memorySnapshotEnd();
	message("windialog memory lost: "+toString(memw_main.getMemoryLostType1())+" or "+toString(memw_main.getMemoryLostType2())+" or "+toString(memw_main.getMemoryLostType3()));
	*/
	//CE SATANÉ BUG C'EST CA:
	/*
	memw_main.memorySnapshotStart();
	float percent=59.25648879f;
	{
		ostringstream ost;
		ost.setf(ios::fixed,ios::floatfield);
		ost.precision(2);
		ost << percent << "%";
		string osttr=ost.str();
	}
	memw_main.memorySnapshotEnd();
	message("ostringstream memory lost: "+toString(memw_main.getMemoryLostType1())+" or "+toString(memw_main.getMemoryLostType2())+" or "+toString(memw_main.getMemoryLostType3()));
	*/
	/*
	memw_main.memorySnapshotStart();
	{
		ostringstream ost;
		ost.setf(ios::fixed,ios::floatfield);
		ost.precision(10);
		ost << percent << "%";
		string osttr=ost.str();
	}
	memw_main.memorySnapshotEnd();
	message("ostringstream 2 memory lost: "+toString(memw_main.getMemoryLostType1())+" or "+toString(memw_main.getMemoryLostType2())+" or "+toString(memw_main.getMemoryLostType3()));
	*/
	
	//toujours revenir ici entre menus et jeux
	while (!osl_quit)
	{
		//malloc_trim(0);
				
		PFL::logFunctionStart("main loop");
		PFL::logMessage("nb images in buffer: "+toString(Anim::getNbBufferedImages()));
		//message("arena: "+toString(mallinfo().arena));
		
		/*int nbimagesinbuffer=Anim::getNbBufferedImages();
		PFL::logMessage("images in buffer: "+toString(nbimagesinbuffer) + " (should be 0)");
		if(nbimagesinbuffer>0)
		{
			Anim::logFilesInBuffer();
			message("images in buffer > 0.\nSee the log file.");
		}
		*/
		PFL::logMessage("endroit = "+toString(endroit));
		
		//TODO:mettre ca pour revenir a pdrom 4 couleurs / QJ
		//if(endroit==MENU_MAIN)
			//endroit=QJ_MENU;
		
		//enableDebug();
		//debug("in main, endroit = "+toString(endroit));
		//enableDebug(false);
		
		endroit_old=endroit;
		
		memw_main.memorySnapshotStart();
		switch(endroit)
		{
			case LOGO_SEQUENCE:
			{
				Logo *logo=new Logo();
				logo->go();
				delete logo;
				
				oslShowSplashScreen(1);
				
				oslInitGfx(GAMEDEF_SCREENMODE, true);
				
//				QJLogo *qjlogo=new QJLogo();
//				qjlogo->go();
//				delete qjlogo;
				
				ShowImage *simg=new ShowImage("res/qj/headphones.png", 45, 150);
				simg->go();
				delete simg;
				
				endroit=MENU_MAIN;
				
				break;	
			}
			case MENU_MAIN:
			{
				initKeyRepeat4Menus();
				
				/*
				mi1=mallinfo();
				//------
				MainMenu *maintestmem=new MainMenu(locale);
				delete maintestmem;
				//------
				mi2=mallinfo();
				message("main menu memory lost: "+toString(mi1.fordblks - mi2.fordblks));
				*/
				
				MainMenu *main=new MainMenu(locale);
				endroit=main->go();
				delete main;
				
				break;
			}
			case MENU_QUIT:
			{
				osl_quit=true;
				//enableDebug();
				//debug("t'as quitte");
				//enableDebug(false);
				break;
			}
			
				
/**********************************************
 *     				TESTS
 **********************************************/
					 
			case TEST_SCENARIO:
			{
				//enableDebug();
				//debug("TestScenario");
				//enableDebug(false);
				TestScenario * test_scenar=new TestScenario();
				endroit=test_scenar->go();
				delete test_scenar;
				break;
			}
			case TEST_LEVELEDITOR:
			{
				TestLevelEditor *tle=new TestLevelEditor();
				endroit=tle->go();			
				delete tle;
				break;
			}
			 
			case LEVELTEST_EASY:
			{	
				initKeyRepeat4Game();
				
				SoloGame *gametest=new SoloGame("test", GAMEDEF_DIFFICULTY_EASY);				
				endroit=gametest->go();		
				delete gametest;	
				
				break;
			}
			case LEVELTEST_NORMAL:
			{	
				initKeyRepeat4Game();
				
				
				SoloGame *gametest=new SoloGame("test", GAMEDEF_DIFFICULTY_NORMAL);
								
				endroit=gametest->go();			
				delete gametest;
				break;
			}
			case LEVELTEST_HARD:
			{	
				initKeyRepeat4Game();
				SoloGame *gametest=new SoloGame("test", GAMEDEF_DIFFICULTY_HARD);
								
				endroit=gametest->go();			
				delete gametest;
				break;
			}
			
			
			
			case LEVELSSOUP_NORMAL:
			{	
				initKeyRepeat4Game();
				
				SoloGame *gamessoup=new SoloGame("ssoup", GAMEDEF_DIFFICULTY_NORMAL);
								
				endroit=gamessoup->go();			
				delete gamessoup;
				break;
			}
			case LEVELSSOUP_HARD:
			{	
				//Loading::startLoading();
				
				initKeyRepeat4Game();
				SoloGame *gamessoup=new SoloGame("ssoup", GAMEDEF_DIFFICULTY_HARD);
				
				//Loading::endLoading();
				
				endroit=gamessoup->go();			
				delete gamessoup;
				break;
			}
			
			case LEVELVOLTIGEUR_NORMAL:
			{
				//Loading::startLoading();
				
				initKeyRepeat4Game();
				
				SoloGame *gamevoltigeur=new SoloGame("voltigeur", GAMEDEF_DIFFICULTY_NORMAL);
				
				//Loading::endLoading();
				
				endroit=gamevoltigeur->go();			
				delete gamevoltigeur;
				break;
			}
			case LEVELVOLTIGEUR_EASY:
			{
				//Loading::startLoading();
				
				initKeyRepeat4Game();
				SoloGame *gamevoltigeur=new SoloGame("voltigeur", GAMEDEF_DIFFICULTY_EASY);
				
				//Loading::endLoading();
				
				endroit=gamevoltigeur->go();			
				delete gamevoltigeur;
				break;
			}
			
			case LEVELVOLTIGEUR_HARD:
			{
				//Loading::startLoading();
				
				initKeyRepeat4Game();
				SoloGame *gamevoltigeur=new SoloGame("voltigeur", GAMEDEF_DIFFICULTY_HARD);
				
				//Loading::endLoading();
				
				endroit=gamevoltigeur->go();			
				delete gamevoltigeur;
				break;
			}
			 
			case LEVELTURNANDBURN_NORMAL:
			{
				//Loading::startLoading();
				
				initKeyRepeat4Game();
				
				
				SoloGame *gametnb=new SoloGame("turnandburn", GAMEDEF_DIFFICULTY_NORMAL);
				
				//Loading::endLoading();
				
				endroit=gametnb->go();			
				delete gametnb;
				break;
			}
			case LEVELTURNANDBURN_HARD:
			{
				//Loading::startLoading();
				
				initKeyRepeat4Game();
				SoloGame *gametnb=new SoloGame("turnandburn", GAMEDEF_DIFFICULTY_HARD);
				
				//Loading::endLoading();
				
				endroit=gametnb->go();			
				delete gametnb;
				break;
			}
			case LEVELBIOTECK_NORMAL:
			{
				//Loading::startLoading();
				
				initKeyRepeat4Game();
				

				
				
				
				SoloGame *gameb=new SoloGame("bioteck", GAMEDEF_DIFFICULTY_NORMAL);
				
				//Loading::endLoading();
				
				endroit=gameb->go();			
				delete gameb;
				break;
			}
			case LEVELBIOTECK_EASY:
			{
				//Loading::startLoading();
				
				initKeyRepeat4Game();
				SoloGame *gameb=new SoloGame("bioteck", GAMEDEF_DIFFICULTY_EASY);
				
				//Loading::endLoading();
				
				endroit=gameb->go();			
				delete gameb;
				break;
			}
			case LEVELBIOTECK_HARD:
			{
				//Loading::startLoading();
				
				initKeyRepeat4Game();
				SoloGame *gameb=new SoloGame("bioteck", GAMEDEF_DIFFICULTY_HARD);
				
				//Loading::endLoading();
				
				endroit=gameb->go();			
				delete gameb;
				break;
			}
			case LEVELTETRIS_EASY:
			{
				/*MemoryWatcher memw;
				
				memw.memorySnapshotStart();
				SoloGame *gamet=new SoloGame("tetris", GAMEDEF_DIFFICULTY_EASY);
				for(int i=0;i<100;i++)
					gamet->update();
				delete gamet;
				memw.memorySnapshotEnd();
				message("tetris easy memory lost: "+toString(memw.getMemoryLostType1())+" or "+toString(memw.getMemoryLostType2())+" or "+toString(memw.getMemoryLostType3()));
						*/		
				initKeyRepeat4Game();
				//Trackable::startTracking();
				SoloGame *gamet=new SoloGame("tetris", GAMEDEF_DIFFICULTY_EASY);
				endroit=gamet->go();			
				delete gamet;
				
				//Trackable::stopTracking();
				//Trackable::dumpToFile();
				
				break;
			}
			case LEVELTETRIS_NORMAL:
			{
				initKeyRepeat4Game();
				
				SoloGame *gamet=new SoloGame("tetris", GAMEDEF_DIFFICULTY_NORMAL);
				endroit=gamet->go();			
				delete gamet;
				break;
			}
			case LEVELTETRIS_HARD:
			{
				initKeyRepeat4Game();
				SoloGame *gamet=new SoloGame("tetris", GAMEDEF_DIFFICULTY_HARD);
				endroit=gamet->go();			
				delete gamet;
				break;
			}
			case LEVELTETRIS_VHARD:
			{
				initKeyRepeat4Game();
				SoloGame *gamet=new SoloGame("tetris", GAMEDEF_DIFFICULTY_VERYHARD);
				endroit=gamet->go();			
				delete gamet;
				break;
			}
			case LEVELMUSONG_NORMAL:
			{
				initKeyRepeat4Game();
				SoloGame *gamem=new SoloGame("musong", GAMEDEF_DIFFICULTY_NORMAL);
				
				endroit=gamem->go();			
				delete gamem;
				break;
			}
			case LEVELSEXY_EASY:
			{
				initKeyRepeat4Game();
				SoloGame *gameps=new SoloGame("sexy", GAMEDEF_DIFFICULTY_EASY);
				endroit=gameps->go();			
				delete gameps;
				break;
			}
			case LEVELSEXY_NORMAL:
			{
				initKeyRepeat4Game();
				
				
				
				SoloGame *gameps=new SoloGame("sexy", GAMEDEF_DIFFICULTY_NORMAL);
				endroit=gameps->go();			
				delete gameps;
				break;
			}
			case LEVELSEXY_HARD:
			{
				initKeyRepeat4Game();
				SoloGame *gameps=new SoloGame("sexy", GAMEDEF_DIFFICULTY_HARD);
				endroit=gameps->go();			
				delete gameps;
				break;
			}
			
			case LEVEL8BITS_EASY:
			{
				initKeyRepeat4Game();
				SoloGame *game8b=new SoloGame("8bits", GAMEDEF_DIFFICULTY_EASY);
				endroit=game8b->go();			
				delete game8b;
				break;
			}
			case LEVEL8BITS_NORMAL:
			{
				initKeyRepeat4Game();
				
				SoloGame *game8b=new SoloGame("8bits", GAMEDEF_DIFFICULTY_NORMAL);
				endroit=game8b->go();			
				delete game8b;
				break;
			}
			case LEVEL8BITS_HARD:
			{
				initKeyRepeat4Game();
				SoloGame *game8b=new SoloGame("8bits", GAMEDEF_DIFFICULTY_HARD);
				endroit=game8b->go();			
				delete game8b;
				break;
			}
			case LEVEL8BITS_BLIXT:
			{
				initKeyRepeat4Game();
				SoloGame *game8b=new SoloGame("8bits", GAMEDEF_DIFFICULTY_BONUS);
				endroit=game8b->go();			
				delete game8b;
				break;
			}
			case LEVELCATHEDRAL_EASY:
			{
				initKeyRepeat4Game();
				SoloGame *gamec=new SoloGame("cathedral", GAMEDEF_DIFFICULTY_EASY);
				endroit=gamec->go();			
				delete gamec;
				break;
			}
			case LEVELCATHEDRAL_NORMAL:
			{
				initKeyRepeat4Game();
				SoloGame *gamec=new SoloGame("cathedral", GAMEDEF_DIFFICULTY_NORMAL);
				endroit=gamec->go();			
				delete gamec;
				break;
			}
			case LEVELCATHEDRAL_HARD:
			{
				initKeyRepeat4Game();
				SoloGame *gamec=new SoloGame("cathedral", GAMEDEF_DIFFICULTY_HARD);
				endroit=gamec->go();			
				delete gamec;
				break;
			}
			case LEVELUNDERWATER_EASY:
			{
				initKeyRepeat4Game();
				SoloGame *gameuw=new SoloGame("underwater", GAMEDEF_DIFFICULTY_EASY);
				endroit=gameuw->go();			
				delete gameuw;
				break;
			}
			case LEVELUNDERWATER_NORMAL:
			{
				initKeyRepeat4Game();
				
				//memory lost: 0
				/*struct mallinfo mi1,mi2;
				for(int j=1;j<=2;j++)
				{
					mi1=mallinfo();
					
					AbstractLevel *levelunderw=LevelFactory::newLevel("underwater");
					ComboCounter *cc=new ComboCounter(); 
					GameGrid *grid=new GameGrid(12, 12, GAMEDEF_PIECE_WIDTH, GAMEDEF_PIECE_HEIGHT); 
					Pair *nextPair=levelunderw->getNewPair();
					Pair *currentPair=levelunderw->getNewPair();
					levelunderw->start();
					//ajout de lignes
					//0 lignes = 0
					//1 ligne = 0
					//2 lignes = 0
					for(int i=0;i<4;i++)
					{
						list<AbstractPiece *> *pline=levelunderw->getNextLine();
						bool ok=grid->addLine(pline); //false=gameover
						if(!ok)
						{
							message("not ok to add line");
						}
					}
					
					//1000 updates
					for(int i=0;i<1000;i++)
					{
						nextPair->update();
						currentPair->update();
						cc->update();
						levelunderw->update(cc, grid, nextPair, currentPair);
					}
					delete cc;
					delete grid;
					delete nextPair;
					delete currentPair;
					delete levelunderw;
					//------
					mi2=mallinfo();
					message(toString(j)+" underw memory lost: "+toString(mi1.fordblks - mi2.fordblks));
				}*/
				
				SoloGame *gameuw=new SoloGame("underwater", GAMEDEF_DIFFICULTY_NORMAL);
				endroit=gameuw->go();			
				
				
				delete gameuw;
				break;
			}
			case LEVELUNDERWATER_HARD:
			{
				initKeyRepeat4Game();
				//Trackable::startTracking();
				
				//Loading *loading=new Loading();
				//loading->start();
				SoloGame *gameuw=new SoloGame("underwater", GAMEDEF_DIFFICULTY_HARD);
				//delete loading;
				
				endroit=gameuw->go();			
				delete gameuw;
				//Trackable::stopTracking();
				//Trackable::dumpToFile();
				
				break;
			}
			case LEVELCHIPTUNES_EASY:
			{
				initKeyRepeat4Game();
				SoloGame *gamechip=new SoloGame("chiptunes", GAMEDEF_DIFFICULTY_EASY);
				endroit=gamechip->go();			
				delete gamechip;
				break;
			}
			case LEVELCHIPTUNES_NORMAL:
			{
				initKeyRepeat4Game();
				//MemoryWatcher memw;
				//memw.memorySnapshotStart();
				SoloGame *gamechip=new SoloGame("chiptunes", GAMEDEF_DIFFICULTY_NORMAL);
				endroit=gamechip->go();			
				delete gamechip;
				//memw.memorySnapshotEnd();
				//message("LEVELCHIPTUNES_NORMAL memory lost: "+toString(memw.getMemoryLostType1())+" or "+toString(memw.getMemoryLostType2())+" or "+toString(memw.getMemoryLostType3()));
				break;
			}
			case LEVELCHIPTUNES_HARD:
			{
				initKeyRepeat4Game();
				//MemoryWatcher memw;
				
				/*
				memw.memorySnapshotStart();
				PieceSimple *piecesimple=new PieceSimple();
				piecesimple->startDestruct();
				while(!piecesimple->destructed())
				{
					piecesimple->update();
					piecesimple->drawXY(50, 50);
				}
				delete piecesimple;
				memw.memorySnapshotEnd();
				message("piecesimple memory lost: "+toString(memw.getMemoryLostType1())+" or "+toString(memw.getMemoryLostType2())+" or "+toString(memw.getMemoryLostType3()));
				
				memw.memorySnapshotStart();
				MatrixContentObject *mco=new MatrixContentObject(new PieceSimple());
				mco->startExplosion(PIECE_MODE_SPECIAL);
				while(!mco->tryCleaning())
				{
					mco->update();
				}
				delete mco;
				memw.memorySnapshotEnd();
				message("mco memory lost: "+toString(memw.getMemoryLostType1())+" or "+toString(memw.getMemoryLostType2())+" or "+toString(memw.getMemoryLostType3()));
				
				memw.memorySnapshotStart();
				FlagMatrix *flags=new FlagMatrix(12, 16);
				flags->setFlagAt(5,6);
				flags->setFlagAt(7,8);
				flags->setFlagAt(9,10);
				delete flags;
				memw.memorySnapshotEnd();
				message("flags memory lost: "+toString(memw.getMemoryLostType1())+" or "+toString(memw.getMemoryLostType2())+" or "+toString(memw.getMemoryLostType3()));
			
				memw.memorySnapshotStart();
				SerialLocalEffect *slfx=new SerialLocalEffect(1);
				slfx->addEffect(new WaitLocalEffect(5));
				slfx->addEffect(new TranslationEffect(0, 0, 0, 50, 10, 10, true, 1));
				for(int i=0;i<100;i++)
					slfx->update();
				delete slfx;
				memw.memorySnapshotEnd();
				message("slfx memory lost: "+toString(memw.getMemoryLostType1())+" or "+toString(memw.getMemoryLostType2())+" or "+toString(memw.getMemoryLostType3()));
			
				
			
				memw.memorySnapshotStart();
				LevelRecordsDialog *lrdialog=new LevelRecordsDialog("chiptunes", GAMEDEF_DIFFICULTY_HARD);
				for(int i=0;i<100;i++)
					lrdialog->update();
				delete lrdialog;
				memw.memorySnapshotEnd();
				message("lrdialog memory lost: "+toString(memw.getMemoryLostType1())+" or "+toString(memw.getMemoryLostType2())+" or "+toString(memw.getMemoryLostType3()));
				
				
				memw.memorySnapshotStart();
				Pair *pair=new Pair(new PieceSimple(), new PieceCombo(12));
				AbstractPiece *ap1,*ap2;
				ap1=pair->detach(0);
				ap2=pair->detach(1);
				pair->getGridPos(0);
				pair->getGridPos(1);
				pair->getPiece(0);
				delete pair;
				delete ap1;
				delete ap2;
				memw.memorySnapshotEnd();
				message("pair memory lost: "+toString(memw.getMemoryLostType1())+" or "+toString(memw.getMemoryLostType2())+" or "+toString(memw.getMemoryLostType3()));
				
				memw.memorySnapshotStart();
				GameGrid *grid=new GameGrid(13, 12, GAMEDEF_PIECE_WIDTH, GAMEDEF_PIECE_HEIGHT);
				for(int i=0;i<100;i++)
					grid->update();
				grid->getContentPosition(5, 6);
				grid->getContentPosition(7, 8);
				grid->getContentPosition(9, 10);
				delete grid;
				memw.memorySnapshotEnd();
				message("grid memory lost: "+toString(memw.getMemoryLostType1())+" or "+toString(memw.getMemoryLostType2())+" or "+toString(memw.getMemoryLostType3()));
				
				memw.memorySnapshotStart();
				GameSave *gamesave=new GameSave();
				gamesave->addWonForLevel("chiptunes", GAMEDEF_DIFFICULTY_HARD);	
				gamesave->setCombosForLevel("chiptunes", GAMEDEF_DIFFICULTY_HARD, 50);
				gamesave->setScoreForLevel("chiptunes", GAMEDEF_DIFFICULTY_HARD, 65895);
				gamesave->addLostForLevel("chiptunes", GAMEDEF_DIFFICULTY_HARD);
				gamesave->save();
				delete gamesave;
				memw.memorySnapshotEnd();
				message("gamesave memory lost: "+toString(memw.getMemoryLostType1())+" or "+toString(memw.getMemoryLostType2())+" or "+toString(memw.getMemoryLostType3()));
				
				memw.memorySnapshotStart();
				ComboCounter *comboc=new ComboCounter();
				Scorer *scorer=new Scorer("chiptunes", GAMEDEF_DIFFICULTY_HARD);
				Timer *timer=new Timer();
				oslSetTextColor(RGB(255,255,255));  
				delete timer;
				delete scorer;
				delete comboc;
				memw.memorySnapshotEnd();
				message("comboc etc memory lost: "+toString(memw.getMemoryLostType1())+" or "+toString(memw.getMemoryLostType2())+" or "+toString(memw.getMemoryLostType3()));
				
				memw.memorySnapshotStart();
				message("test de message");
				memw.memorySnapshotEnd();
				message("message memory lost: "+toString(memw.getMemoryLostType1())+" or "+toString(memw.getMemoryLostType2())+" or "+toString(memw.getMemoryLostType3()));
				
				memw.memorySnapshotStart();
				LinePattern *linepattern=new LinePattern("res/levels/underwater/underwater_normal.pattern", 1);
				for(int i=0;i<10;i++)
					linepattern->getNextLine();
				delete linepattern;
				memw.memorySnapshotEnd();
				message("linepattern memory lost: "+toString(memw.getMemoryLostType1())+" or "+toString(memw.getMemoryLostType2())+" or "+toString(memw.getMemoryLostType3()));
				
				memw.memorySnapshotStart();
				Anim *anim=new Anim(5, "square_constant_", "res/levels/underwater/piece_special/", 200);
				Anim *anim2=new Anim(10, "circle", "res/pieces/circle/", GAMEDEF_EXPLOSION_TIME, OSL_PF_8888, 1);
				Anim *anim3=new Anim(5, "square_constant_", "res/levels/underwater/piece_special/", 200);
				Anim *anim4=new Anim(10, "circle", "res/pieces/circle/", GAMEDEF_EXPLOSION_TIME, OSL_PF_8888, 1);
				for(int i=0; i<35; i++)
				{
					anim->addImage("res/levels/underwater/piece_special/square_constant_5.png", OSL_PF_8888);
				}
				for(int i=0;i<100;i++)
				{
					anim->update();
					anim2->update();
				}
				delete anim;
				delete anim2;
				delete anim3;
				delete anim4;
				memw.memorySnapshotEnd();
				message("anims memory lost: "+toString(memw.getMemoryLostType1())+" or "+toString(memw.getMemoryLostType2())+" or "+toString(memw.getMemoryLostType3()));
				
				memw.memorySnapshotStart();
				SongBanner *songbanner=new SongBanner(GAMEDEF_SONGBANNER_Y, "res/fonts/bmpFonts/russelsquare/15/nosmooth/", "normal", "italic", "texte 1", ":ljkhsd ojsdkl jnj", "", "");
				for(int i=0;i<100;i++)
					songbanner->update();
				delete songbanner;
				memw.memorySnapshotEnd();
				message("songbanner memory lost: "+toString(memw.getMemoryLostType1())+" or "+toString(memw.getMemoryLostType2())+" or "+toString(memw.getMemoryLostType3()));
				
				memw.memorySnapshotStart();
				EventsScenario *scenario=new EventsScenario("res/tests/test.scenario");
				scenario->restart();
				for(int i=0;i<30;i++)
				{
					scenario->update();
					scenario->hasEvent(1);
					scenario->hasEvent(2);
					scenario->hasEvent(3);
					scenario->hasEvent(4);
					scenario->hasEvent(5);
					scenario->hasEvent(6);
					sceDisplayWaitVblankStart();
				}
				delete scenario;
				memw.memorySnapshotEnd();
				message("scenario memory lost: "+toString(memw.getMemoryLostType1())+" or "+toString(memw.getMemoryLostType2())+" or "+toString(memw.getMemoryLostType3()));
				
				memw.memorySnapshotStart();
				BmpFont *font_big=new BmpFont("res/fonts/bmpFonts/angie/22/", "angie", OSL_PF_8888);
				BmpText *text_title=new BmpText("Records:", font_big);
				text_title->compile();
				delete font_big;
				delete text_title;
				memw.memorySnapshotEnd();
				message("bmpfont memory lost: "+toString(memw.getMemoryLostType1())+" or "+toString(memw.getMemoryLostType2())+" or "+toString(memw.getMemoryLostType3()));
				
				memw.memorySnapshotStart();
				PleaseWaitSound *pws=new PleaseWaitSound();
				for(int i=0;i<300;i++)
				{
					pws->update();
					sceDisplayWaitVblankStart();
				}
				delete pws;
				memw.memorySnapshotEnd();
				message("pleasewaitsound memory lost: "+toString(memw.getMemoryLostType1())+" or "+toString(memw.getMemoryLostType2())+" or "+toString(memw.getMemoryLostType3()));
				
				memw.memorySnapshotStart();
				LoadingRes *res=new LoadingRes();
				delete res;
				message("loadingres memory lost: "+toString(memw.getMemoryLostType1())+" or "+toString(memw.getMemoryLostType2())+" or "+toString(memw.getMemoryLostType3()));
				*/
				
				
				/*
				memw.memorySnapshotStart();
				Loading *loading=new Loading();
				loading->start();
				delete loading;
				memw.memorySnapshotEnd();
				PFL::logMessage("loading memory lost: "+toString(memw.getMemoryLostType1())+" or "+toString(memw.getMemoryLostType2())+" or "+toString(memw.getMemoryLostType3()));
				*/
				
				//memw.memorySnapshotStart();
				//SoloGame *test=new SoloGame("chiptunes", GAMEDEF_DIFFICULTY_HARD);
				//delete test;
				//memw.memorySnapshotEnd();
				//message("SoloGame memory lost: "+toString(memw.getMemoryLostType1())+" or "+toString(memw.getMemoryLostType2())+" or "+toString(memw.getMemoryLostType3()));
				
				//memw.memorySnapshotStart();
				//FlagMatrix *flags=new FlagMatrix(12, 16);
				//flags->setFlagAt(5,6);
				//flags->setFlagAt(7,8);
				//flags->setFlagAt(9,10);
				//delete flags;
				//memw.memorySnapshotEnd();
				//message("flags memory lost: "+toString(memw.getMemoryLostType1())+" or "+toString(memw.getMemoryLostType2())+" or "+toString(memw.getMemoryLostType3()));
				
				/*memw.memorySnapshotStart();
				Anim *anim=new Anim(5, "square_constant_", "res/levels/underwater/piece_special/", 200);
				Anim *anim2=new Anim(10, "circle", "res/pieces/circle/", GAMEDEF_EXPLOSION_TIME, OSL_PF_8888, 1);
				Anim *anim3=new Anim(5, "square_constant_", "res/levels/underwater/piece_special/", 200);
				Anim *anim4=new Anim(10, "circle", "res/pieces/circle/", GAMEDEF_EXPLOSION_TIME, OSL_PF_8888, 1);
				for(int i=0; i<35; i++)
				{
					anim->addImage("res/levels/underwater/piece_special/square_constant_5.png", OSL_PF_8888);
				}
				for(int i=0;i<100;i++)
				{
					anim->update();
					anim2->update();
				}
				delete anim;
				delete anim2;
				delete anim3;
				delete anim4;
				memw.memorySnapshotEnd();
				message("anims memory lost: "+toString(memw.getMemoryLostType1())+" or "+toString(memw.getMemoryLostType2())+" or "+toString(memw.getMemoryLostType3()));
				
				
				*/
				//Trackable::startTracking();
				SoloGame *gamechip=new SoloGame("chiptunes", GAMEDEF_DIFFICULTY_HARD);
				endroit=gamechip->go();			
				delete gamechip;
				//Trackable::stopTracking();
				//Trackable::dumpToFile();
				break;
			}
						
			case LEVELFROZEN_EASY :
			{
				initKeyRepeat4Game();
				SoloGame *pdr4cgamef=new SoloGame("pdr4cfrozen", GAMEDEF_DIFFICULTY_EASY);
				endroit=pdr4cgamef->go();			
				delete pdr4cgamef;
				break;
			}
			case LEVELFROZEN_NORMAL :
			{
				initKeyRepeat4Game();
								
				SoloGame *pdr4cgamef=new SoloGame("pdr4cfrozen", GAMEDEF_DIFFICULTY_NORMAL);
				endroit=pdr4cgamef->go();			
				delete pdr4cgamef;
				break;
			}
			case LEVELFROZEN_HARD :
			{
				initKeyRepeat4Game();
				SoloGame *pdr4cgamef=new SoloGame("pdr4cfrozen", GAMEDEF_DIFFICULTY_HARD);
				endroit=pdr4cgamef->go();			
				delete pdr4cgamef;
				break;
			}
			case LEVELFROZEN_VHARD :
			{
				initKeyRepeat4Game();
				SoloGame *pdr4cgamef=new SoloGame("pdr4cfrozen", GAMEDEF_DIFFICULTY_VERYHARD);
				endroit=pdr4cgamef->go();			
				delete pdr4cgamef;
				break;
			}
			case LEVELDJBEAT_EASY :
			{
				initKeyRepeat4Game();
				SoloGame *pdr4cgamedjb=new SoloGame("pdr4cdjbeat", GAMEDEF_DIFFICULTY_EASY);
				endroit=pdr4cgamedjb->go();			
				delete pdr4cgamedjb;
				break;
			}
			case LEVELDJBEAT_NORMAL :
			{
				initKeyRepeat4Game();
				
				SoloGame *pdr4cgamedjb=new SoloGame("pdr4cdjbeat", GAMEDEF_DIFFICULTY_NORMAL);
				endroit=pdr4cgamedjb->go();			
				delete pdr4cgamedjb;
				break;
			}
			case LEVELDJBEAT_HARD :
			{
				initKeyRepeat4Game();
				SoloGame *pdr4cgamedjb=new SoloGame("pdr4cdjbeat", GAMEDEF_DIFFICULTY_HARD);
				endroit=pdr4cgamedjb->go();			
				delete pdr4cgamedjb;
				break;
			}
			
			case LEVELMECHA_EASY :
			{
				initKeyRepeat4Game();
				SoloGame *pdr4cgamemecha=new SoloGame("pdr4cmecha", GAMEDEF_DIFFICULTY_EASY);
				endroit=pdr4cgamemecha->go();			
				delete pdr4cgamemecha;
				break;
			}
			case LEVELMECHA_NORMAL :
			{
				initKeyRepeat4Game();
				SoloGame *pdr4cgamemecha=new SoloGame("pdr4cmecha", GAMEDEF_DIFFICULTY_NORMAL);
				endroit=pdr4cgamemecha->go();			
				delete pdr4cgamemecha;
				break;
			}
			case LEVELMECHA_HARD :
			{
				initKeyRepeat4Game();
				SoloGame *pdr4cgamemecha=new SoloGame("pdr4cmecha", GAMEDEF_DIFFICULTY_HARD);
				endroit=pdr4cgamemecha->go();			
				delete pdr4cgamemecha;
				break;
			}
			
			
						 
			//par défaut on retourne au main menu avec un avertissement
			default:
			{
				enableDebug();
				debug("action non definie, retour à main...");
				enableDebug(false);
				endroit=MENU_MAIN;
				break;
			}
		}//fin switch
		
		//malloc_trim(0);
		
		//là il veut recommencer le stage
		if(endroit==MENU_REDOTHESAME)
		{
			endroit=endroit_old;
		}
		
		//malloc_trim(0);
		/*
		struct mallinfo mallinf_after=mallinfo();
		string mess="main loop memory lost: ";
		mess=mess+toString(mallinf_after.fordblks-mallinf_before.fordblks);
		mess=mess+"\nor ";
		mess=mess+toString(mallinf_before.uordblks-mallinf_after.uordblks);
		mess=mess+"\nor ";
		mess=mess+toString(mallinf_after.arena-mallinf_before.arena);
		message(mess);
		*/
		//memw_main.memorySnapshotEnd();
		//message("main loop memory lost: "+toString(memw_main.getMemoryLostType1())+" or "+toString(memw_main.getMemoryLostType2())+" or "+toString(memw_main.getMemoryLostType3()));
		//message("nb images buffered: "+toString(Anim::getNbBufferedImages()));
		
		PFL::logFunctionEnd("main loop");
	}//fin while
	/*enableDebug();
	debug("fin de la boucle principale");
	enableDebug(false);*/
	
	deinit();
	oslEndGfx();
	oslQuit();
	return 0;
}














