#include "code/tests/TestAppearDown.h"
#include <oslib/oslib.h>
#include <string>
#include "code/framework/utils.h"
#include "code/game/menus/MenusDefines.h"
#include "code/framework/fx/EffectsLib.h"

using namespace std;
using namespace utils;

//construction
TestAppearDown::TestAppearDown()
{
	oslSetKeyAutorepeat(OSL_KEYMASK_UP|OSL_KEYMASK_DOWN,40,4);
	
	m_action=MENU_NOACTION;
	m_skip=false;
	
	m_img=oslLoadImageFilePNG("res/tests/testtransp.png", OSL_IN_RAM|OSL_SWIZZLED, OSL_PF_4444);
	
	m_fx_appearWait=new SerialLocalEffect(1);
	m_fx_appearWait->addEffect(new AppearDownEffect(50));
	m_fx_appearWait->addEffect(new WaitLocalEffect(60));
	
	m_fx_waitVanish=new SerialGlobalEffect(1);
	m_fx_waitVanish->addEffect(new WaitGlobalEffect(80));
	m_fx_waitVanish->addEffect(new ProgressiveAlphaEffect(30, 30, 255, 0, 1));
	
}

//destruction
TestAppearDown::~TestAppearDown()
{
	delete m_fx_appearWait;
	delete m_fx_waitVanish;
	oslDeleteImage(m_img);
}

//demarrage du menu
int TestAppearDown::go()
{
	while(m_action==MENU_NOACTION)
	{
		oslBenchmarkTest(OSL_BENCH_START);
		
		//touches
		m_action=keys();
		if(m_action==MENU_QUIT)
			return m_action;
		
		//phase d'update
		m_fx_appearWait->update();
		m_fx_waitVanish->update();
				
		if (!m_skip)
		{
			//phase de dessin
			oslStartDrawing();
			drawScene();
			oslBenchmarkTest(OSL_BENCH_END);
			oslSysBenchmarkDisplay();
			oslEndDrawing();
		}
		
		//End of a frame
        oslEndFrame();
		//Synchronize to ensure the game runs at 60 fps
        m_skip = oslSyncFrame();
		//oslAudioVSync(); //ne sert plus, oslEndFrame le fait
	}
	//il a choisi une option
	enableDebug();
	debug("fin boucle TestAppearDown, return "+toString(m_action));
	enableDebug(false);
	
	return m_action;	
}

//dessins
void TestAppearDown::drawScene()
{
	oslClearScreen(RGB(255,128,128));
	
	if(m_fx_waitVanish->isRunning())
	{
		AlphaParamsState alpha;
		alpha.saveState();
		
		m_fx_waitVanish->activate();
		fx::drawXY(m_img, 50, 120, m_fx_appearWait);
		
		alpha.restoreState();
	}
}

//gestion des touches
int TestAppearDown::keys()
{
	oslReadKeys();
	if (osl_pad.pressed.start) //Exit 
	{
		enableDebug();
		debug("start!");
		enableDebug(false);
		return MENU_MAIN;
	}
	
	if(osl_pad.pressed.R)
	{
		m_fx_appearWait->restart();
		m_fx_waitVanish->restart();
	}
	else if(osl_pad.pressed.L)
	{
		
	}
	
	
		
	
	return MENU_NOACTION;
}











































