#include "code/tests/TestDrawImageOnImage.h"
#include <oslib/oslib.h>
#include "code/framework/utils.h"
#include "code/game/menus/MenusDefines.h"

using namespace std;
using namespace utils;

//construction
TestDrawImageOnImage::TestDrawImageOnImage()
{
	m_action=MENU_NOACTION;
	m_skip=false;
	
	m_img_bg=oslLoadImageFilePNG("res/tests/imageonimage/bg.png", OSL_IN_RAM | OSL_SWIZZLED, OSL_PF_8888);
	//m_img1=oslLoadImageFilePNG("res/tests/imageonimage/img1.png", OSL_IN_RAM | OSL_SWIZZLED, OSL_PF_8888);
	//m_img2=oslLoadImageFilePNG("res/tests/imageonimage/img2.png", OSL_IN_RAM | OSL_SWIZZLED, OSL_PF_8888);
	
	m_img1=oslLoadImageFilePNG("res/tests/imageonimage/72429-3784082289.png", OSL_IN_RAM | OSL_SWIZZLED, OSL_PF_8888);
	m_img2=oslLoadImageFilePNG("res/menus/whiterect50.png", OSL_IN_RAM | OSL_SWIZZLED, OSL_PF_8888);
	
	
	m_img_res=oslCreateImageCopy(m_img1,OSL_IN_RAM); 	
	//enableDebug();
	//drawImageOnImage(m_img2, 0, 0, m_img2->sizeX, m_img2->sizeY, m_img_res, 0, 0);
	drawImageOnImage(m_img2, 0, 0, m_img2->sizeX, m_img2->sizeY, m_img_res, 60, 60);
}

//destruction
TestDrawImageOnImage::~TestDrawImageOnImage()
{
	oslDeleteImage(m_img_bg);
	oslDeleteImage(m_img1);
	oslDeleteImage(m_img2);
	oslDeleteImage(m_img_res);
	
}

int TestDrawImageOnImage::go()
{
	while(m_action==MENU_NOACTION)
	{
		oslBenchmarkTest(OSL_BENCH_START);
		
		//touches
		m_action=keys();
		if(m_action==MENU_QUIT)
			return m_action;
		
		//phase d'update
		
				
		if (!m_skip)
		{
			//phase de dessin
			oslStartDrawing();
			drawScene();
			oslBenchmarkTest(OSL_BENCH_END);
			oslSysBenchmarkDisplay();
			oslEndDrawing();
		}
		
		//End of a frame
        oslEndFrame();
		//Synchronize to ensure the game runs at 60 fps
        m_skip = oslSyncFrame();
		//oslAudioVSync(); //ne sert plus, oslEndFrame le fait
	}
	//il a choisi une option
	enableDebug();
	debug("fin boucle TestDrawImageOnImage, return "+toString(m_action));
	enableDebug(false);
	
	return m_action;	
}

//dessins
void TestDrawImageOnImage::drawScene()
{
	//oslDrawImageXY(m_img_bg, 0, 0);
	//oslDrawImageXY(m_img1, 60, 50);
	//oslDrawImageXY(m_img2, 480-60-m_img2->sizeX, 50);
	oslDrawImageXY(m_img_res, 0, 0);
	
	//oslPrintf_xy(230, 90, "+");
	//oslPrintf_xy(150, 210, "=");
}

//gestion des touches
int TestDrawImageOnImage::keys()
{
	oslReadKeys();
	if (osl_pad.pressed.start) //Exit 
	{
		return MENU_MAIN;
	}
		
	return MENU_NOACTION;
}





































