#include "code/tests/TestMegaman.h"
#include <oslib/oslib.h>
#include "code/framework/utils.h"
#include "code/game/menus/MenusDefines.h"
#include "code/framework/particles/complete/animFactories/ExtractImageFromAnimFactory.h"
#include "code/framework/fx/EffectsLib.h"

using namespace utils;
//construction
TestMegaman::TestMegaman()
{
	oslSetKeyAutorepeat(OSL_KEYMASK_UP|OSL_KEYMASK_DOWN,40,4);
	
	m_action=MENU_NOACTION;
	m_skip=false;
	
	
	m_megaman = new Anim(9, "mx", "res/tests/anim/mx/", 54.0f);
	m_megaman->setReferencePointCenter();
	m_megaman->setX(0);
	m_megaman->setY(200);
	m_megaman->start();
	
	int lifespan=16;
	ExtractImageFromAnimFactory * animf=new ExtractImageFromAnimFactory(m_megaman);
	m_gen = new ParticleGeneratorPoint(0, 200, 0, 1, 1, 4, 1, 0, lifespan, animf);
	
	//changement de couleur et disparition
	SerialGlobalEffect * sge=new SerialGlobalEffect(0);
	//sge->addEffect(new ProgressiveTintEffect(int(lifespan/2), 0, RGBA(200,128,200,255), RGBA(192,64,192,192), 1));
	//sge->addEffect(new ProgressiveTintEffect(int(lifespan/2), 0, RGBA(192,64,192,192), RGBA(128,0,128,0), 1));
	sge->addEffect(new ProgressiveTintEffect(int(lifespan/2), 0, RGBA(200,128,200,255), RGBA(128,0,128,192), 1));
	sge->addEffect(new ProgressiveTintEffect(int(lifespan/2), 0, RGBA(128,0,128,192), RGBA(128,0,128,0), 1));
	
	
	m_gen->setGlobalEffect1(sge);
	
	m_x=0;
	
}

//destruction
TestMegaman::~TestMegaman()
{
	delete m_megaman;
	delete m_gen;
}

//demarrage du menu
int TestMegaman::go()
{
	m_gen->start();
	m_gen->generationOff();
	
	while(m_action==MENU_NOACTION)
	{
		oslBenchmarkTest(OSL_BENCH_START);
		
		//touches
		m_action=keys();
		if(m_action==MENU_QUIT)
			return m_action;
		
		//phase d'update
		m_megaman->update();
		m_gen->update();
		//m_x++;
		if(m_x>480)
			m_x=0;
		m_megaman->setX(m_x);
		m_gen->setX(m_x);
			
		if (!m_skip)
		{
			//phase de dessin
			oslStartDrawing();
			drawScene();
			oslBenchmarkTest(OSL_BENCH_END);
			oslSysBenchmarkDisplay();
			oslEndDrawing();
		}
		
		//End of a frame
        oslEndFrame();
		//Synchronize to ensure the game runs at 60 fps
        m_skip = oslSyncFrame();
		//oslAudioVSync(); //ne sert plus, oslEndFrame le fait
	}
	//il a choisi une option
	enableDebug();
	debug("fin boucle TestMegaman, return "+toString(m_action));
	enableDebug(false);
	
	return m_action;	
}

//dessins
void TestMegaman::drawScene()
{
	oslClearScreen(RGB(255,128,192));
	
	m_gen->draw();
	m_megaman->draw();
	
}

//gestion des touches
int TestMegaman::keys()
{
	oslReadKeys();
	if (osl_pad.pressed.start) //Exit 
	{
		enableDebug();
		debug("start!");
		enableDebug(false);
		return MENU_MAIN;
	}
	
	if(osl_pad.pressed.R)
	{
		
	}
	else if(osl_pad.pressed.L)
	{
		//m_gen->generationSwitchOnOff();
	}
	
	//ca va être appelé a chaque boucle, pas terrible
	if(osl_pad.analogX<50)
	{
		m_x++;
		m_megaman->setDelayTotal(54.0f);
		m_gen->generationOff();
	}
	else if(osl_pad.analogX<100)
	{
		m_x+=2;
		m_megaman->setDelayTotal(30.0f);
		m_gen->generationOn();
	}
	else
	{
		m_x+=3;
		m_megaman->setDelayTotal(19.0f);
		m_gen->generationOn();
	}
	
	return MENU_NOACTION;
}





































