#include "code/tests/TestRMX.h"

#include <oslib/oslib.h>
#include <string>
#include "code/framework/utils.h"
#include "code/game/menus/MenusDefines.h"
//#include "code/framework/resRepo/RmxArchive.h"
//#include "code/framework/resRepo/FolderRepo.h"
#include "code/framework/resRepo/ResRepoFactory.h"

using namespace std;
using namespace utils;

//construction
TestRMX::TestRMX()
{	
	//enableDebug();
	m_action=MENU_NOACTION;
	m_skip=false;
	
	m_mode=RESREPO_TYPE_FOLDER; //mode d'archivage
	ResRepoFactory::setRepoType(m_mode);
	//m_rmx=new RmxArchive("res/tests/rmx/bob.rmx");
	//m_name="res/tests/rmx/resources";
	
	
	
	readEverythingFromArchive();
	
//	istream *stream=m_rmx->readTextFileStream("bob.txt");
//	
//	string line;
//	while(getline(*stream,line))
//	{
//		debug(line);
//	}
//	
//	delete stream;
	
	
	
	
	
//	debug("extraction....");
//	//test d'exctraction
//	vector<RmxFileDetails>::iterator it;
//	for(it=m_details_in_archive.begin();it!=m_details_in_archive.end();it++)
//	{
//		RmxFileDetails rmxd=(*it);
//		debug("extraction "+rmxd.m_name+"\nvers "+"extraction/"+rmxd.m_name);
//		if(m_rmx->extractFileTo(rmxd.m_name, "extraction/"+rmxd.m_name))
//			debug("ok");
//		else
//			debug("couldn't extract file");
//	}
	
	
	//createDirectory("essai/de/creation/repertoires/multiples");
	//createDirectory("essai/de/");
	
	//debug(filepath_getpath("bob/le/marrant/fichier.txt"));
	//debug(filepath_getfile("bob/le/marrant/fichier.txt"));
	
	//enableDebug(false);
}

//destruction
TestRMX::~TestRMX()
{
	delete m_rmx;
	oslDeleteImage(m_img);
	oslDeleteSound(m_snd);
}

//demarrage du menu
int TestRMX::go()
{
	while(m_action==MENU_NOACTION)
	{
		oslBenchmarkTest(OSL_BENCH_START);
		
		//touches
		m_action=keys();
		if(m_action==MENU_QUIT)
			return m_action;
		
		//phase d'update
		
				
		if (!m_skip)
		{
			//phase de dessin
			oslStartDrawing();
			drawScene();
			oslBenchmarkTest(OSL_BENCH_END);
			oslSysBenchmarkDisplay();
			oslEndDrawing();
		}
		
		//End of a frame
        oslEndFrame();
		//Synchronize to ensure the game runs at 60 fps
        m_skip = oslSyncFrame();
		//oslAudioVSync(); //ne sert plus, oslEndFrame le fait
	}
	//il a choisi une option
	enableDebug();
	debug("fin boucle TestRMX, return "+toString(m_action));
	enableDebug(false);
	
	return m_action;	
}

//dessins
void TestRMX::drawScene()
{
	oslClearScreen(RGB(0,0,0));
	
	oslDrawImage(m_img);
	
	oslDrawString(10, 10, m_rmx->getName().c_str());
	
	vector<ResFileDetails>::iterator it;
	int y=30;
	for(it=m_details_in_archive.begin();it!=m_details_in_archive.end();it++)
	{
		ResFileDetails rmxd=(*it);
		oslDrawString(10, y, (rmxd.m_name + " " + toString(rmxd.m_offset) + " " + toString(rmxd.m_size)).c_str());
		y+=15;
	}
	
	oslDrawString(10, y, m_text.c_str());
	
	if(m_mode==RESREPO_TYPE_FOLDER)
		oslDrawString(10, 250, "FOLDER MODE");
	else
		oslDrawString(10, 250, "RMX MODE");
	
}

//gestion des touches
int TestRMX::keys()
{
	oslReadKeys();
	if (osl_pad.pressed.start) //Exit 
	{
		enableDebug();
		debug("start!");
		enableDebug(false);
		return MENU_MAIN;
	}
	
	
	if(osl_pad.pressed.cross)
	{
		oslPlaySound(m_snd, 0);
	}
	
	if(osl_pad.pressed.select)
	{
		changeMode();
	}
	
	if(osl_pad.pressed.triangle)
	{
		//enableDebug();
		oslDebug("extraction...");
		if(!m_rmx->extractAllToFolder("res/tests/rmx/extraction"))
		{
			oslDebug("error during extraction.");
		}
		//enableDebug(false);
	}
	
	return MENU_NOACTION;
}


void TestRMX::changeMode()
{
	//on change de mode
	if(m_mode==RESREPO_TYPE_RMX)
		m_mode=RESREPO_TYPE_FOLDER;
	else
		m_mode=RESREPO_TYPE_RMX;
	ResRepoFactory::setRepoType(m_mode);
		
	//on efface tout
	oslDeleteImage(m_img);
	oslDeleteSound(m_snd);
	delete m_rmx;
	m_details_in_archive.clear();
	
	//on reconstruit avec le nouveau mode
	readEverythingFromArchive();
	
	
}

void TestRMX::readEverythingFromArchive()
{
	if(m_mode==RESREPO_TYPE_RMX)
		m_rmx=ResRepoFactory::newInstance("res/tests/rmx/bob.rmx");
	else
		m_rmx=ResRepoFactory::newInstance("res/tests/rmx/folder");
		
	
	m_details_in_archive=m_rmx->getFilesDetails();
	m_text=m_rmx->readTextFileString("bob/bobinfolder.txt");
	m_img=m_rmx->readPngFile("bob.png", OSL_IN_RAM|OSL_SWIZZLED, OSL_PF_8888);
	oslImageCenterScreen(m_img);
	m_snd=m_rmx->readBgmFile("bob.bgm");
}




































