#include "code/tests/TestTranslationFX.h"
#include <oslib/oslib.h>
#include "code/framework/utils.h"
#include "code/framework/fx/EffectsLib.h"
#include "code/game/menus/MenusDefines.h"



//construction
TestTranslationFX::TestTranslationFX()
{
	//enableDebug();
	//debug("creation TestTranslationFX");
	m_action=MENU_NOACTION;
	m_skip=false;

	m_x=240;
	m_y=136;
		
	m_repere=oslLoadImageFilePNG("res/pieces/cross/cross1.png", OSL_SWIZZLED | OSL_IN_RAM, OSL_PF_8888);
	m_affected=oslLoadImageFilePNG("res/pieces/star/star1.png", OSL_SWIZZLED | OSL_IN_RAM, OSL_PF_8888);
	
	m_fx_transl=new TranslationEffect(80, 0, 0, -80, 60, 60);	
	
	oslImageSetRotCenter(m_repere);
	oslImageSetRotCenter(m_affected);
	//debug("creation ok");
	//enableDebug(false);
}

//destruction
TestTranslationFX::~TestTranslationFX()
{
	oslDeleteImage(m_repere);
	oslDeleteImage(m_affected);
	
	delete m_fx_transl;
}

//demarrage du menu
int TestTranslationFX::go()
{
	m_fx_transl->start();
	
	while(m_action==MENU_NOACTION)
	{
		oslBenchmarkTest(OSL_BENCH_START);
		
		//touches
		m_action=keys();
		if(m_action==MENU_QUIT)
			return m_action;
		
		//phase d'update
		m_fx_transl->update();
		
		
		if (!m_skip)
		{
			//phase de dessin
			oslStartDrawing();
			drawScene();
			oslBenchmarkTest(OSL_BENCH_END);
			oslSysBenchmarkDisplay();
			oslEndDrawing();
		}
		
		//End of a frame
        oslEndFrame();
		//Synchronize to ensure the game runs at 60 fps
        m_skip = oslSyncFrame();
		//oslAudioVSync(); //ne sert plus, oslEndFrame le fait
	}
	//il a choisi une option
	enableDebug();
	debug("fin boucle main, return "+toString(m_action));
	enableDebug(false);
	
	
	return m_action;	
}

//dessins
void TestTranslationFX::drawScene()
{
	oslClearScreen(RGB(0,0,0));
	//oslSetAlpha(OSL_FX_ALPHA | OSL_FX_COLOR, RGBA(128, 128, 255, 255));
	
	oslDrawImageXY(m_repere, m_x, m_y);
	fx::drawXY(m_affected, m_x, m_y, m_fx_transl);
	
	
}

//gestion des touches
int TestTranslationFX::keys()
{
	oslReadKeys();
	if (osl_pad.pressed.start) //Exit 
	{
		enableDebug();
		debug("start!");
		enableDebug(false);
		return MENU_MAIN;
	}
	
	//switch pause on/off
	if(osl_pad.pressed.triangle)
	{
		
	}
	
	if(osl_pad.pressed.R)
	{

	}
	else if(osl_pad.pressed.L)
	{
		
	}
	
	if(osl_pad.analogX>=100)
		m_x+=8;
	else if(osl_pad.analogX>=70)
		m_x+=4;
	else if(osl_pad.analogX>=20)
		m_x++;
	
	if(osl_pad.analogX<=-100)
		m_x-=8;
	else if(osl_pad.analogX<=-70)
		m_x-=4;
	else if(osl_pad.analogX<=-20)
		m_x--;
	
	if(osl_pad.analogY>=100)
		m_y+=8;
	else if(osl_pad.analogY>=70)
		m_y+=4;
	else if(osl_pad.analogY>=20)
		m_y++;
	
	if(osl_pad.analogY<=-100)
		m_y-=8;
	if(osl_pad.analogY<=-70)
		m_y-=4;
	if(osl_pad.analogY<=-20)
		m_y--;
		
	
	if (osl_pad.pressed.up)
	{
		
	}
	else if(osl_pad.pressed.down)
	{
		
	}
	

	else if(osl_pad.pressed.left)
	{
		
	}
	else if(osl_pad.pressed.right)
	{
		
	}
	
	if(osl_pad.pressed.select)
	{
		
	}
	
	return MENU_NOACTION;
}
































